/* action.c generated by valac 0.56.9, the Vala compiler
 * generated from action.vala, do not modify */

/*
 * Copyright (c) 2016 gnome-pomodoro contributors
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include "actions.h"
#include <stdlib.h>
#include <string.h>
#include <glib.h>
#include <gio/gio.h>
#include <glib-object.h>
#include <float.h>
#include <math.h>
#include <stdio.h>

enum  {
	ACTIONS_ACTION_0_PROPERTY,
	ACTIONS_ACTION_NAME_PROPERTY,
	ACTIONS_ACTION_COMMAND_PROPERTY,
	ACTIONS_ACTION_PATH_PROPERTY,
	ACTIONS_ACTION_STATES_PROPERTY,
	ACTIONS_ACTION_TRIGGERS_PROPERTY,
	ACTIONS_ACTION_COMMAND_VALID_PROPERTY,
	ACTIONS_ACTION_NUM_PROPERTIES
};
static GParamSpec* actions_action_properties[ACTIONS_ACTION_NUM_PROPERTIES];
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_regex_unref0(var) ((var == NULL) ? NULL : (var = (g_regex_unref (var), NULL)))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))

struct _ActionsActionPrivate {
	gchar* _name;
	ActionsState _states;
	ActionsTrigger _triggers;
	gboolean _command_valid;
	gchar* _command;
	GSettings* settings;
	GSimpleAction* remove_action;
};

static gint ActionsAction_private_offset;
static gpointer actions_action_parent_class = NULL;
static GType actions_action_type_id = 0;

static void actions_action_activate_remove (ActionsAction* self,
                                     GSimpleAction* action,
                                     GVariant* parameter);
static void _actions_action_activate_remove_g_simple_action_activate (GSimpleAction* _sender,
                                                               GVariant* parameter,
                                                               gpointer self);
static void actions_action_validate_command (ActionsAction* self);
static void actions_action_set_command_valid (ActionsAction* self,
                                       gboolean value);
static void _vala_array_add2 (gchar** * array,
                       gint* length,
                       gint* size,
                       gchar* value);
static void actions_action_finalize (GObject * obj);
static void _vala_actions_action_get_property (GObject * object,
                                        guint property_id,
                                        GValue * value,
                                        GParamSpec * pspec);
static void _vala_actions_action_set_property (GObject * object,
                                        guint property_id,
                                        const GValue * value,
                                        GParamSpec * pspec);
static void _vala_array_destroy (gpointer array,
                          gssize array_length,
                          GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array,
                       gssize array_length,
                       GDestroyNotify destroy_func);
static gssize _vala_array_length (gpointer array);

static inline gpointer
actions_action_get_instance_private (ActionsAction* self)
{
	return G_STRUCT_MEMBER_P (self, ActionsAction_private_offset);
}

ActionsAction*
actions_action_construct_for_path (GType object_type,
                                   const gchar* path)
{
	ActionsAction * self = NULL;
#line 76 "../plugins/actions/action.vala"
	g_return_val_if_fail (path != NULL, NULL);
#line 76 "../plugins/actions/action.vala"
	self = (ActionsAction*) g_object_new (object_type, NULL);
#line 78 "../plugins/actions/action.vala"
	actions_action_set_path (self, path);
#line 76 "../plugins/actions/action.vala"
	return self;
#line 112 "action.c"
}

ActionsAction*
actions_action_new_for_path (const gchar* path)
{
#line 76 "../plugins/actions/action.vala"
	return actions_action_construct_for_path (ACTIONS_TYPE_ACTION, path);
#line 120 "action.c"
}

/**
         * Reset action to defaults
         */
void
actions_action_reset (ActionsAction* self)
{
	GSettings* _tmp0_;
	GSettings* _tmp1_;
	GSettings* _tmp2_;
	GSettings* _tmp3_;
	GSettings* _tmp4_;
	GSettings* _tmp5_;
#line 84 "../plugins/actions/action.vala"
	g_return_if_fail (self != NULL);
#line 86 "../plugins/actions/action.vala"
	_tmp0_ = self->priv->settings;
#line 86 "../plugins/actions/action.vala"
	g_settings_delay (_tmp0_);
#line 87 "../plugins/actions/action.vala"
	_tmp1_ = self->priv->settings;
#line 87 "../plugins/actions/action.vala"
	g_settings_reset (_tmp1_, "name");
#line 88 "../plugins/actions/action.vala"
	_tmp2_ = self->priv->settings;
#line 88 "../plugins/actions/action.vala"
	g_settings_reset (_tmp2_, "command");
#line 89 "../plugins/actions/action.vala"
	_tmp3_ = self->priv->settings;
#line 89 "../plugins/actions/action.vala"
	g_settings_reset (_tmp3_, "states");
#line 90 "../plugins/actions/action.vala"
	_tmp4_ = self->priv->settings;
#line 90 "../plugins/actions/action.vala"
	g_settings_reset (_tmp4_, "triggers");
#line 91 "../plugins/actions/action.vala"
	_tmp5_ = self->priv->settings;
#line 91 "../plugins/actions/action.vala"
	g_settings_apply (_tmp5_);
#line 161 "action.c"
}

static void
_actions_action_activate_remove_g_simple_action_activate (GSimpleAction* _sender,
                                                          GVariant* parameter,
                                                          gpointer self)
{
#line 99 "../plugins/actions/action.vala"
	actions_action_activate_remove ((ActionsAction*) self, _sender, parameter);
#line 171 "action.c"
}

GActionGroup*
actions_action_get_action_group (ActionsAction* self)
{
	GSimpleActionGroup* action_group = NULL;
	GSimpleActionGroup* _tmp0_;
	GSimpleAction* _tmp1_;
	GSimpleAction* _tmp2_;
	GSimpleAction* _tmp3_;
	GActionGroup* result;
#line 94 "../plugins/actions/action.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 96 "../plugins/actions/action.vala"
	_tmp0_ = g_simple_action_group_new ();
#line 96 "../plugins/actions/action.vala"
	action_group = _tmp0_;
#line 98 "../plugins/actions/action.vala"
	_tmp1_ = g_simple_action_new ("remove", NULL);
#line 98 "../plugins/actions/action.vala"
	_g_object_unref0 (self->priv->remove_action);
#line 98 "../plugins/actions/action.vala"
	self->priv->remove_action = _tmp1_;
#line 99 "../plugins/actions/action.vala"
	_tmp2_ = self->priv->remove_action;
#line 99 "../plugins/actions/action.vala"
	g_signal_connect_object (_tmp2_, "activate", (GCallback) _actions_action_activate_remove_g_simple_action_activate, self, 0);
#line 100 "../plugins/actions/action.vala"
	_tmp3_ = self->priv->remove_action;
#line 100 "../plugins/actions/action.vala"
	g_action_map_add_action ((GActionMap*) action_group, (GAction*) _tmp3_);
#line 102 "../plugins/actions/action.vala"
	result = (GActionGroup*) action_group;
#line 102 "../plugins/actions/action.vala"
	return result;
#line 207 "action.c"
}

static void
actions_action_activate_remove (ActionsAction* self,
                                GSimpleAction* action,
                                GVariant* parameter)
{
	ActionsActionManager* action_manager = NULL;
	ActionsActionManager* _tmp0_;
#line 105 "../plugins/actions/action.vala"
	g_return_if_fail (self != NULL);
#line 105 "../plugins/actions/action.vala"
	g_return_if_fail (action != NULL);
#line 108 "../plugins/actions/action.vala"
	_tmp0_ = actions_action_manager_get_instance ();
#line 108 "../plugins/actions/action.vala"
	action_manager = _tmp0_;
#line 110 "../plugins/actions/action.vala"
	actions_action_manager_remove (action_manager, self);
#line 105 "../plugins/actions/action.vala"
	_g_object_unref0 (action_manager);
#line 229 "action.c"
}

static void
actions_action_validate_command (ActionsAction* self)
{
	gchar** spawn_args = NULL;
	gint spawn_args_length1 = 0;
	gint _spawn_args_size_ = 0;
	GError* _inner_error0_ = NULL;
#line 113 "../plugins/actions/action.vala"
	g_return_if_fail (self != NULL);
#line 241 "action.c"
	{
		gboolean _tmp0_ = FALSE;
		const gchar* _tmp1_;
		const gchar* _tmp2_;
		gchar** _tmp3_ = NULL;
		gint _tmp4_ = 0;
		gboolean _tmp5_;
#line 118 "../plugins/actions/action.vala"
		_tmp1_ = actions_action_get_command (self);
#line 118 "../plugins/actions/action.vala"
		_tmp2_ = _tmp1_;
#line 118 "../plugins/actions/action.vala"
		_tmp5_ = g_shell_parse_argv (_tmp2_, &_tmp4_, &_tmp3_, &_inner_error0_);
#line 118 "../plugins/actions/action.vala"
		spawn_args = (_vala_array_free (spawn_args, spawn_args_length1, (GDestroyNotify) g_free), NULL);
#line 118 "../plugins/actions/action.vala"
		spawn_args = _tmp3_;
#line 118 "../plugins/actions/action.vala"
		spawn_args_length1 = _tmp4_;
#line 118 "../plugins/actions/action.vala"
		_spawn_args_size_ = spawn_args_length1;
#line 118 "../plugins/actions/action.vala"
		_tmp0_ = _tmp5_;
#line 118 "../plugins/actions/action.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 118 "../plugins/actions/action.vala"
			if (_inner_error0_->domain == G_SHELL_ERROR) {
#line 269 "action.c"
				goto __catch0_g_shell_error;
			}
#line 118 "../plugins/actions/action.vala"
			spawn_args = (_vala_array_free (spawn_args, spawn_args_length1, (GDestroyNotify) g_free), NULL);
#line 118 "../plugins/actions/action.vala"
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 118 "../plugins/actions/action.vala"
			g_clear_error (&_inner_error0_);
#line 118 "../plugins/actions/action.vala"
			return;
#line 280 "action.c"
		}
#line 118 "../plugins/actions/action.vala"
		actions_action_set_command_valid (self, _tmp0_);
#line 284 "action.c"
	}
	goto __finally0;
	__catch0_g_shell_error:
	{
#line 117 "../plugins/actions/action.vala"
		g_clear_error (&_inner_error0_);
#line 122 "../plugins/actions/action.vala"
		actions_action_set_command_valid (self, FALSE);
#line 293 "action.c"
	}
	__finally0:
#line 117 "../plugins/actions/action.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 117 "../plugins/actions/action.vala"
		spawn_args = (_vala_array_free (spawn_args, spawn_args_length1, (GDestroyNotify) g_free), NULL);
#line 117 "../plugins/actions/action.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 117 "../plugins/actions/action.vala"
		g_clear_error (&_inner_error0_);
#line 117 "../plugins/actions/action.vala"
		return;
#line 306 "action.c"
	}
#line 113 "../plugins/actions/action.vala"
	spawn_args = (_vala_array_free (spawn_args, spawn_args_length1, (GDestroyNotify) g_free), NULL);
#line 310 "action.c"
}

static void
_vala_array_add2 (gchar** * array,
                  gint* length,
                  gint* size,
                  gchar* value)
{
#line 134 "../plugins/actions/action.vala"
	if ((*length) == (*size)) {
#line 134 "../plugins/actions/action.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 134 "../plugins/actions/action.vala"
		*array = g_renew (gchar*, *array, (*size) + 1);
#line 325 "action.c"
	}
#line 134 "../plugins/actions/action.vala"
	(*array)[(*length)++] = value;
#line 134 "../plugins/actions/action.vala"
	(*array)[*length] = NULL;
#line 331 "action.c"
}

static gchar*
string_replace (const gchar* self,
                const gchar* old,
                const gchar* replacement)
{
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
	GError* _inner_error0_ = NULL;
	gchar* result;
#line 1542 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, NULL);
#line 1542 "glib-2.0.vapi"
	g_return_val_if_fail (old != NULL, NULL);
#line 1542 "glib-2.0.vapi"
	g_return_val_if_fail (replacement != NULL, NULL);
#line 1543 "glib-2.0.vapi"
	if ((*((gchar*) self)) == '\0') {
#line 1543 "glib-2.0.vapi"
		_tmp1_ = TRUE;
#line 353 "action.c"
	} else {
#line 1543 "glib-2.0.vapi"
		_tmp1_ = (*((gchar*) old)) == '\0';
#line 357 "action.c"
	}
#line 1543 "glib-2.0.vapi"
	if (_tmp1_) {
#line 1543 "glib-2.0.vapi"
		_tmp0_ = TRUE;
#line 363 "action.c"
	} else {
#line 1543 "glib-2.0.vapi"
		_tmp0_ = g_strcmp0 (old, replacement) == 0;
#line 367 "action.c"
	}
#line 1543 "glib-2.0.vapi"
	if (_tmp0_) {
#line 371 "action.c"
		gchar* _tmp2_;
#line 1544 "glib-2.0.vapi"
		_tmp2_ = g_strdup (self);
#line 1544 "glib-2.0.vapi"
		result = _tmp2_;
#line 1544 "glib-2.0.vapi"
		return result;
#line 379 "action.c"
	}
	{
		GRegex* regex = NULL;
		gchar* _tmp3_;
		gchar* _tmp4_;
		GRegex* _tmp5_;
		GRegex* _tmp6_;
		gchar* _tmp7_ = NULL;
		GRegex* _tmp8_;
		gchar* _tmp9_;
		gchar* _tmp10_;
#line 1547 "glib-2.0.vapi"
		_tmp3_ = g_regex_escape_string (old, -1);
#line 1547 "glib-2.0.vapi"
		_tmp4_ = _tmp3_;
#line 1547 "glib-2.0.vapi"
		_tmp5_ = g_regex_new (_tmp4_, 0, 0, &_inner_error0_);
#line 1547 "glib-2.0.vapi"
		_tmp6_ = _tmp5_;
#line 1547 "glib-2.0.vapi"
		_g_free0 (_tmp4_);
#line 1547 "glib-2.0.vapi"
		regex = _tmp6_;
#line 1547 "glib-2.0.vapi"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1547 "glib-2.0.vapi"
			if (_inner_error0_->domain == G_REGEX_ERROR) {
#line 407 "action.c"
				goto __catch0_g_regex_error;
			}
#line 1547 "glib-2.0.vapi"
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1547 "glib-2.0.vapi"
			g_clear_error (&_inner_error0_);
#line 1547 "glib-2.0.vapi"
			return NULL;
#line 416 "action.c"
		}
#line 1548 "glib-2.0.vapi"
		_tmp8_ = regex;
#line 1548 "glib-2.0.vapi"
		_tmp9_ = g_regex_replace_literal (_tmp8_, self, (gssize) -1, 0, replacement, 0, &_inner_error0_);
#line 1548 "glib-2.0.vapi"
		_tmp7_ = _tmp9_;
#line 1548 "glib-2.0.vapi"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1548 "glib-2.0.vapi"
			_g_regex_unref0 (regex);
#line 1548 "glib-2.0.vapi"
			if (_inner_error0_->domain == G_REGEX_ERROR) {
#line 430 "action.c"
				goto __catch0_g_regex_error;
			}
#line 1548 "glib-2.0.vapi"
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1548 "glib-2.0.vapi"
			g_clear_error (&_inner_error0_);
#line 1548 "glib-2.0.vapi"
			return NULL;
#line 439 "action.c"
		}
#line 1548 "glib-2.0.vapi"
		_tmp10_ = _tmp7_;
#line 1548 "glib-2.0.vapi"
		_tmp7_ = NULL;
#line 1548 "glib-2.0.vapi"
		result = _tmp10_;
#line 1548 "glib-2.0.vapi"
		_g_free0 (_tmp7_);
#line 1548 "glib-2.0.vapi"
		_g_regex_unref0 (regex);
#line 1548 "glib-2.0.vapi"
		return result;
#line 453 "action.c"
	}
	goto __finally0;
	__catch0_g_regex_error:
	{
#line 1546 "glib-2.0.vapi"
		g_clear_error (&_inner_error0_);
#line 1550 "glib-2.0.vapi"
		g_assert_not_reached ();
#line 462 "action.c"
	}
	__finally0:
#line 1546 "glib-2.0.vapi"
	g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1546 "glib-2.0.vapi"
	g_clear_error (&_inner_error0_);
#line 1546 "glib-2.0.vapi"
	return NULL;
#line 471 "action.c"
}

static gchar*
double_to_string (gdouble self)
{
	gchar* _tmp0_;
	gchar* _tmp1_;
	gint _tmp1__length1;
	const gchar* _tmp2_;
	gchar* _tmp3_;
	gchar* _tmp4_;
	gchar* result;
#line 997 "glib-2.0.vapi"
	_tmp0_ = g_new0 (gchar, G_ASCII_DTOSTR_BUF_SIZE);
#line 997 "glib-2.0.vapi"
	_tmp1_ = _tmp0_;
#line 997 "glib-2.0.vapi"
	_tmp1__length1 = G_ASCII_DTOSTR_BUF_SIZE;
#line 997 "glib-2.0.vapi"
	_tmp2_ = g_ascii_dtostr (_tmp1_, (gint) G_ASCII_DTOSTR_BUF_SIZE, self);
#line 997 "glib-2.0.vapi"
	_tmp3_ = g_strdup (_tmp2_);
#line 997 "glib-2.0.vapi"
	_tmp4_ = _tmp3_;
#line 997 "glib-2.0.vapi"
	_tmp1_ = (g_free (_tmp1_), NULL);
#line 997 "glib-2.0.vapi"
	result = _tmp4_;
#line 997 "glib-2.0.vapi"
	return result;
#line 502 "action.c"
}

static gchar*
_vala_g_strjoinv (const gchar* separator,
                  gchar** str_array,
                  gint str_array_length1)
{
	gboolean _tmp0_ = FALSE;
	gchar* result;
#line 1208 "glib-2.0.vapi"
	if (separator == NULL) {
#line 1209 "glib-2.0.vapi"
		separator = "";
#line 516 "action.c"
	}
#line 1211 "glib-2.0.vapi"
	if (str_array != NULL) {
#line 520 "action.c"
		gboolean _tmp1_ = FALSE;
#line 1211 "glib-2.0.vapi"
		if (str_array_length1 > 0) {
#line 1211 "glib-2.0.vapi"
			_tmp1_ = TRUE;
#line 526 "action.c"
		} else {
			gboolean _tmp2_ = FALSE;
#line 1211 "glib-2.0.vapi"
			if (str_array_length1 == -1) {
#line 531 "action.c"
				const gchar* _tmp3_;
#line 1211 "glib-2.0.vapi"
				_tmp3_ = str_array[0];
#line 1211 "glib-2.0.vapi"
				_tmp2_ = _tmp3_ != NULL;
#line 537 "action.c"
			} else {
#line 1211 "glib-2.0.vapi"
				_tmp2_ = FALSE;
#line 541 "action.c"
			}
#line 1211 "glib-2.0.vapi"
			_tmp1_ = _tmp2_;
#line 545 "action.c"
		}
#line 1211 "glib-2.0.vapi"
		_tmp0_ = _tmp1_;
#line 549 "action.c"
	} else {
#line 1211 "glib-2.0.vapi"
		_tmp0_ = FALSE;
#line 553 "action.c"
	}
#line 1211 "glib-2.0.vapi"
	if (_tmp0_) {
#line 557 "action.c"
		gint i = 0;
		gsize len = 0UL;
		gint _tmp16_;
		gint _tmp17_;
		const gchar* res = NULL;
		void* _tmp18_;
		const gchar* _tmp19_ = NULL;
		const gchar* _tmp20_;
		void* ptr = NULL;
		const gchar* _tmp22_;
		void* _tmp23_;
		const gchar* _tmp33_;
#line 1213 "glib-2.0.vapi"
		len = (gsize) 1;
#line 572 "action.c"
		{
			gboolean _tmp4_ = FALSE;
#line 1214 "glib-2.0.vapi"
			i = 0;
#line 1214 "glib-2.0.vapi"
			_tmp4_ = TRUE;
#line 1214 "glib-2.0.vapi"
			while (TRUE) {
#line 581 "action.c"
				gboolean _tmp6_ = FALSE;
				gboolean _tmp7_ = FALSE;
				gint _tmp10_ = 0;
				const gchar* _tmp11_;
#line 1214 "glib-2.0.vapi"
				if (!_tmp4_) {
#line 588 "action.c"
					gint _tmp5_;
#line 1214 "glib-2.0.vapi"
					_tmp5_ = i;
#line 1214 "glib-2.0.vapi"
					i = _tmp5_ + 1;
#line 594 "action.c"
				}
#line 1214 "glib-2.0.vapi"
				_tmp4_ = FALSE;
#line 1214 "glib-2.0.vapi"
				if (str_array_length1 != -1) {
#line 1214 "glib-2.0.vapi"
					_tmp7_ = i < str_array_length1;
#line 602 "action.c"
				} else {
#line 1214 "glib-2.0.vapi"
					_tmp7_ = FALSE;
#line 606 "action.c"
				}
#line 1214 "glib-2.0.vapi"
				if (_tmp7_) {
#line 1214 "glib-2.0.vapi"
					_tmp6_ = TRUE;
#line 612 "action.c"
				} else {
					gboolean _tmp8_ = FALSE;
#line 1214 "glib-2.0.vapi"
					if (str_array_length1 == -1) {
#line 617 "action.c"
						const gchar* _tmp9_;
#line 1214 "glib-2.0.vapi"
						_tmp9_ = str_array[i];
#line 1214 "glib-2.0.vapi"
						_tmp8_ = _tmp9_ != NULL;
#line 623 "action.c"
					} else {
#line 1214 "glib-2.0.vapi"
						_tmp8_ = FALSE;
#line 627 "action.c"
					}
#line 1214 "glib-2.0.vapi"
					_tmp6_ = _tmp8_;
#line 631 "action.c"
				}
#line 1214 "glib-2.0.vapi"
				if (!_tmp6_) {
#line 1214 "glib-2.0.vapi"
					break;
#line 637 "action.c"
				}
#line 1215 "glib-2.0.vapi"
				_tmp11_ = str_array[i];
#line 1215 "glib-2.0.vapi"
				if (_tmp11_ != NULL) {
#line 643 "action.c"
					const gchar* _tmp12_;
					gint _tmp13_;
					gint _tmp14_;
#line 1215 "glib-2.0.vapi"
					_tmp12_ = str_array[i];
#line 1215 "glib-2.0.vapi"
					_tmp13_ = strlen ((const gchar*) _tmp12_);
#line 1215 "glib-2.0.vapi"
					_tmp14_ = _tmp13_;
#line 1215 "glib-2.0.vapi"
					_tmp10_ = _tmp14_;
#line 655 "action.c"
				} else {
#line 1215 "glib-2.0.vapi"
					_tmp10_ = 0;
#line 659 "action.c"
				}
#line 1215 "glib-2.0.vapi"
				len += (gsize) _tmp10_;
#line 663 "action.c"
			}
		}
#line 1217 "glib-2.0.vapi"
		if (i == 0) {
#line 668 "action.c"
			gchar* _tmp15_;
#line 1218 "glib-2.0.vapi"
			_tmp15_ = g_strdup ("");
#line 1218 "glib-2.0.vapi"
			result = _tmp15_;
#line 1218 "glib-2.0.vapi"
			return result;
#line 676 "action.c"
		}
#line 1220 "glib-2.0.vapi"
		str_array_length1 = i;
#line 1221 "glib-2.0.vapi"
		_tmp16_ = strlen ((const gchar*) separator);
#line 1221 "glib-2.0.vapi"
		_tmp17_ = _tmp16_;
#line 1221 "glib-2.0.vapi"
		len += (gsize) (_tmp17_ * (i - 1));
#line 1223 "glib-2.0.vapi"
		_tmp18_ = g_malloc (len);
#line 1223 "glib-2.0.vapi"
		res = _tmp18_;
#line 1224 "glib-2.0.vapi"
		_tmp20_ = str_array[0];
#line 1224 "glib-2.0.vapi"
		if (_tmp20_ != NULL) {
#line 694 "action.c"
			const gchar* _tmp21_;
#line 1224 "glib-2.0.vapi"
			_tmp21_ = str_array[0];
#line 1224 "glib-2.0.vapi"
			_tmp19_ = (const gchar*) _tmp21_;
#line 700 "action.c"
		} else {
#line 1224 "glib-2.0.vapi"
			_tmp19_ = "";
#line 704 "action.c"
		}
#line 1224 "glib-2.0.vapi"
		_tmp22_ = res;
#line 1224 "glib-2.0.vapi"
		_tmp23_ = g_stpcpy ((void*) _tmp22_, _tmp19_);
#line 1224 "glib-2.0.vapi"
		ptr = _tmp23_;
#line 712 "action.c"
		{
			gboolean _tmp24_ = FALSE;
#line 1225 "glib-2.0.vapi"
			i = 1;
#line 1225 "glib-2.0.vapi"
			_tmp24_ = TRUE;
#line 1225 "glib-2.0.vapi"
			while (TRUE) {
#line 721 "action.c"
				void* _tmp26_;
				void* _tmp27_;
				const gchar* _tmp28_ = NULL;
				const gchar* _tmp29_;
				void* _tmp31_;
				void* _tmp32_;
#line 1225 "glib-2.0.vapi"
				if (!_tmp24_) {
#line 730 "action.c"
					gint _tmp25_;
#line 1225 "glib-2.0.vapi"
					_tmp25_ = i;
#line 1225 "glib-2.0.vapi"
					i = _tmp25_ + 1;
#line 736 "action.c"
				}
#line 1225 "glib-2.0.vapi"
				_tmp24_ = FALSE;
#line 1225 "glib-2.0.vapi"
				if (!(i < str_array_length1)) {
#line 1225 "glib-2.0.vapi"
					break;
#line 744 "action.c"
				}
#line 1226 "glib-2.0.vapi"
				_tmp26_ = ptr;
#line 1226 "glib-2.0.vapi"
				_tmp27_ = g_stpcpy (_tmp26_, (const gchar*) separator);
#line 1226 "glib-2.0.vapi"
				ptr = _tmp27_;
#line 1227 "glib-2.0.vapi"
				_tmp29_ = str_array[i];
#line 1227 "glib-2.0.vapi"
				if (_tmp29_ != NULL) {
#line 756 "action.c"
					const gchar* _tmp30_;
#line 1227 "glib-2.0.vapi"
					_tmp30_ = str_array[i];
#line 1227 "glib-2.0.vapi"
					_tmp28_ = (const gchar*) _tmp30_;
#line 762 "action.c"
				} else {
#line 1227 "glib-2.0.vapi"
					_tmp28_ = "";
#line 766 "action.c"
				}
#line 1227 "glib-2.0.vapi"
				_tmp31_ = ptr;
#line 1227 "glib-2.0.vapi"
				_tmp32_ = g_stpcpy (_tmp31_, _tmp28_);
#line 1227 "glib-2.0.vapi"
				ptr = _tmp32_;
#line 774 "action.c"
			}
		}
#line 1230 "glib-2.0.vapi"
		_tmp33_ = res;
#line 1230 "glib-2.0.vapi"
		res = NULL;
#line 1230 "glib-2.0.vapi"
		result = (gchar*) _tmp33_;
#line 1230 "glib-2.0.vapi"
		return result;
#line 785 "action.c"
	} else {
		gchar* _tmp34_;
#line 1232 "glib-2.0.vapi"
		_tmp34_ = g_strdup ("");
#line 1232 "glib-2.0.vapi"
		result = _tmp34_;
#line 1232 "glib-2.0.vapi"
		return result;
#line 794 "action.c"
	}
}

gboolean
actions_action_execute (ActionsAction* self,
                        ActionsContext* context)
{
	gchar** spawn_env = NULL;
	gchar** _tmp0_;
	gchar** _tmp1_;
	gint spawn_env_length1;
	gint _spawn_env_size_;
	gchar** spawn_args = NULL;
	gint spawn_args_length1 = 0;
	gint _spawn_args_size_ = 0;
	gchar** trigger_strings = NULL;
	gchar** _tmp2_;
	gint trigger_strings_length1;
	gint _trigger_strings_size_;
	ActionsContext _tmp3_;
	GList* _tmp4_;
	gchar* command = NULL;
	const gchar* _tmp6_;
	const gchar* _tmp7_;
	gchar* _tmp8_;
	const gchar* _tmp9_;
	ActionsContext _tmp10_;
	gchar* _tmp11_;
	gchar* _tmp12_;
	gchar* _tmp13_;
	const gchar* _tmp14_;
	ActionsContext _tmp15_;
	gchar* _tmp16_;
	gchar* _tmp17_;
	gchar* _tmp18_;
	const gchar* _tmp19_;
	ActionsContext _tmp20_;
	gchar* _tmp21_;
	gchar* _tmp22_;
	gchar* _tmp23_;
	const gchar* _tmp24_;
	gchar** _tmp25_;
	gint _tmp25__length1;
	gchar* _tmp26_;
	gchar* _tmp27_;
	gchar* _tmp28_;
	GError* _inner_error0_ = NULL;
	gboolean result;
#line 126 "../plugins/actions/action.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 126 "../plugins/actions/action.vala"
	g_return_val_if_fail (context != NULL, FALSE);
#line 128 "../plugins/actions/action.vala"
	_tmp1_ = _tmp0_ = g_get_environ ();
#line 128 "../plugins/actions/action.vala"
	spawn_env = _tmp1_;
#line 128 "../plugins/actions/action.vala"
	spawn_env_length1 = _vala_array_length (_tmp0_);
#line 128 "../plugins/actions/action.vala"
	_spawn_env_size_ = spawn_env_length1;
#line 130 "../plugins/actions/action.vala"
	_tmp2_ = g_new0 (gchar*, 0 + 1);
#line 130 "../plugins/actions/action.vala"
	trigger_strings = _tmp2_;
#line 130 "../plugins/actions/action.vala"
	trigger_strings_length1 = 0;
#line 130 "../plugins/actions/action.vala"
	_trigger_strings_size_ = trigger_strings_length1;
#line 132 "../plugins/actions/action.vala"
	_tmp3_ = *context;
#line 132 "../plugins/actions/action.vala"
	_tmp4_ = actions_trigger_to_list (_tmp3_.triggers);
#line 867 "action.c"
	{
		GList* trigger_collection = NULL;
		GList* trigger_it = NULL;
#line 132 "../plugins/actions/action.vala"
		trigger_collection = _tmp4_;
#line 132 "../plugins/actions/action.vala"
		for (trigger_it = trigger_collection; trigger_it != NULL; trigger_it = trigger_it->next) {
#line 875 "action.c"
			ActionsTrigger trigger = 0U;
#line 132 "../plugins/actions/action.vala"
			trigger = (ActionsTrigger) ((gintptr) trigger_it->data);
#line 879 "action.c"
			{
				gchar* _tmp5_;
#line 134 "../plugins/actions/action.vala"
				_tmp5_ = actions_trigger_to_string (trigger);
#line 134 "../plugins/actions/action.vala"
				_vala_array_add2 (&trigger_strings, &trigger_strings_length1, &_trigger_strings_size_, _tmp5_);
#line 886 "action.c"
			}
		}
#line 132 "../plugins/actions/action.vala"
		(trigger_collection == NULL) ? NULL : (trigger_collection = (g_list_free (trigger_collection), NULL));
#line 891 "action.c"
	}
#line 137 "../plugins/actions/action.vala"
	_tmp6_ = actions_action_get_command (self);
#line 137 "../plugins/actions/action.vala"
	_tmp7_ = _tmp6_;
#line 137 "../plugins/actions/action.vala"
	_tmp8_ = g_strdup (_tmp7_);
#line 137 "../plugins/actions/action.vala"
	command = _tmp8_;
#line 138 "../plugins/actions/action.vala"
	_tmp9_ = command;
#line 138 "../plugins/actions/action.vala"
	_tmp10_ = *context;
#line 138 "../plugins/actions/action.vala"
	_tmp11_ = actions_state_to_string (_tmp10_.state);
#line 138 "../plugins/actions/action.vala"
	_tmp12_ = _tmp11_;
#line 138 "../plugins/actions/action.vala"
	_tmp13_ = string_replace (_tmp9_, "$(state)", _tmp12_);
#line 138 "../plugins/actions/action.vala"
	_g_free0 (command);
#line 138 "../plugins/actions/action.vala"
	command = _tmp13_;
#line 138 "../plugins/actions/action.vala"
	_g_free0 (_tmp12_);
#line 140 "../plugins/actions/action.vala"
	_tmp14_ = command;
#line 140 "../plugins/actions/action.vala"
	_tmp15_ = *context;
#line 140 "../plugins/actions/action.vala"
	_tmp16_ = double_to_string (_tmp15_.elapsed);
#line 140 "../plugins/actions/action.vala"
	_tmp17_ = _tmp16_;
#line 140 "../plugins/actions/action.vala"
	_tmp18_ = string_replace (_tmp14_, "$(elapsed)", _tmp17_);
#line 140 "../plugins/actions/action.vala"
	_g_free0 (command);
#line 140 "../plugins/actions/action.vala"
	command = _tmp18_;
#line 140 "../plugins/actions/action.vala"
	_g_free0 (_tmp17_);
#line 142 "../plugins/actions/action.vala"
	_tmp19_ = command;
#line 142 "../plugins/actions/action.vala"
	_tmp20_ = *context;
#line 142 "../plugins/actions/action.vala"
	_tmp21_ = double_to_string (_tmp20_.duration);
#line 142 "../plugins/actions/action.vala"
	_tmp22_ = _tmp21_;
#line 142 "../plugins/actions/action.vala"
	_tmp23_ = string_replace (_tmp19_, "$(duration)", _tmp22_);
#line 142 "../plugins/actions/action.vala"
	_g_free0 (command);
#line 142 "../plugins/actions/action.vala"
	command = _tmp23_;
#line 142 "../plugins/actions/action.vala"
	_g_free0 (_tmp22_);
#line 144 "../plugins/actions/action.vala"
	_tmp24_ = command;
#line 144 "../plugins/actions/action.vala"
	_tmp25_ = trigger_strings;
#line 144 "../plugins/actions/action.vala"
	_tmp25__length1 = trigger_strings_length1;
#line 144 "../plugins/actions/action.vala"
	_tmp26_ = _vala_g_strjoinv (" ", _tmp25_, (gint) _tmp25__length1);
#line 144 "../plugins/actions/action.vala"
	_tmp27_ = _tmp26_;
#line 144 "../plugins/actions/action.vala"
	_tmp28_ = string_replace (_tmp24_, "$(triggers)", _tmp27_);
#line 144 "../plugins/actions/action.vala"
	_g_free0 (command);
#line 144 "../plugins/actions/action.vala"
	command = _tmp28_;
#line 144 "../plugins/actions/action.vala"
	_g_free0 (_tmp27_);
#line 967 "action.c"
	{
		const gchar* _tmp29_;
		gchar** _tmp30_ = NULL;
		gint _tmp31_ = 0;
#line 148 "../plugins/actions/action.vala"
		_tmp29_ = command;
#line 148 "../plugins/actions/action.vala"
		g_shell_parse_argv (_tmp29_, &_tmp31_, &_tmp30_, &_inner_error0_);
#line 148 "../plugins/actions/action.vala"
		spawn_args = (_vala_array_free (spawn_args, spawn_args_length1, (GDestroyNotify) g_free), NULL);
#line 148 "../plugins/actions/action.vala"
		spawn_args = _tmp30_;
#line 148 "../plugins/actions/action.vala"
		spawn_args_length1 = _tmp31_;
#line 148 "../plugins/actions/action.vala"
		_spawn_args_size_ = spawn_args_length1;
#line 148 "../plugins/actions/action.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 986 "action.c"
			gboolean _tmp32_ = FALSE;
#line 148 "../plugins/actions/action.vala"
			if (_inner_error0_->domain == G_SHELL_ERROR) {
#line 990 "action.c"
				goto __catch0_g_shell_error;
			}
#line 148 "../plugins/actions/action.vala"
			_g_free0 (command);
#line 148 "../plugins/actions/action.vala"
			trigger_strings = (_vala_array_free (trigger_strings, trigger_strings_length1, (GDestroyNotify) g_free), NULL);
#line 148 "../plugins/actions/action.vala"
			spawn_args = (_vala_array_free (spawn_args, spawn_args_length1, (GDestroyNotify) g_free), NULL);
#line 148 "../plugins/actions/action.vala"
			spawn_env = (_vala_array_free (spawn_env, spawn_env_length1, (GDestroyNotify) g_free), NULL);
#line 148 "../plugins/actions/action.vala"
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 148 "../plugins/actions/action.vala"
			g_clear_error (&_inner_error0_);
#line 148 "../plugins/actions/action.vala"
			return _tmp32_;
#line 1007 "action.c"
		}
	}
	goto __finally0;
	__catch0_g_shell_error:
	{
		GError* _error_ = NULL;
		const gchar* _tmp33_;
		GError* _tmp34_;
		const gchar* _tmp35_;
#line 147 "../plugins/actions/action.vala"
		_error_ = _inner_error0_;
#line 147 "../plugins/actions/action.vala"
		_inner_error0_ = NULL;
#line 151 "../plugins/actions/action.vala"
		_tmp33_ = command;
#line 151 "../plugins/actions/action.vala"
		_tmp34_ = _error_;
#line 151 "../plugins/actions/action.vala"
		_tmp35_ = _tmp34_->message;
#line 151 "../plugins/actions/action.vala"
		g_debug ("action.vala:151: Error while executing command \"%s\": %s", _tmp33_, _tmp35_);
#line 152 "../plugins/actions/action.vala"
		result = FALSE;
#line 152 "../plugins/actions/action.vala"
		_g_error_free0 (_error_);
#line 152 "../plugins/actions/action.vala"
		_g_free0 (command);
#line 152 "../plugins/actions/action.vala"
		trigger_strings = (_vala_array_free (trigger_strings, trigger_strings_length1, (GDestroyNotify) g_free), NULL);
#line 152 "../plugins/actions/action.vala"
		spawn_args = (_vala_array_free (spawn_args, spawn_args_length1, (GDestroyNotify) g_free), NULL);
#line 152 "../plugins/actions/action.vala"
		spawn_env = (_vala_array_free (spawn_env, spawn_env_length1, (GDestroyNotify) g_free), NULL);
#line 152 "../plugins/actions/action.vala"
		return result;
#line 1043 "action.c"
	}
	__finally0:
#line 147 "../plugins/actions/action.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1048 "action.c"
		gboolean _tmp36_ = FALSE;
#line 147 "../plugins/actions/action.vala"
		_g_free0 (command);
#line 147 "../plugins/actions/action.vala"
		trigger_strings = (_vala_array_free (trigger_strings, trigger_strings_length1, (GDestroyNotify) g_free), NULL);
#line 147 "../plugins/actions/action.vala"
		spawn_args = (_vala_array_free (spawn_args, spawn_args_length1, (GDestroyNotify) g_free), NULL);
#line 147 "../plugins/actions/action.vala"
		spawn_env = (_vala_array_free (spawn_env, spawn_env_length1, (GDestroyNotify) g_free), NULL);
#line 147 "../plugins/actions/action.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 147 "../plugins/actions/action.vala"
		g_clear_error (&_inner_error0_);
#line 147 "../plugins/actions/action.vala"
		return _tmp36_;
#line 1064 "action.c"
	}
	{
		gchar** _tmp37_;
		gint _tmp37__length1;
		gchar** _tmp38_;
		gint _tmp38__length1;
#line 156 "../plugins/actions/action.vala"
		_tmp37_ = spawn_args;
#line 156 "../plugins/actions/action.vala"
		_tmp37__length1 = spawn_args_length1;
#line 156 "../plugins/actions/action.vala"
		_tmp38_ = spawn_env;
#line 156 "../plugins/actions/action.vala"
		_tmp38__length1 = spawn_env_length1;
#line 156 "../plugins/actions/action.vala"
		g_spawn_sync ("/", _tmp37_, _tmp38_, G_SPAWN_SEARCH_PATH, NULL, NULL, NULL, NULL, NULL, &_inner_error0_);
#line 156 "../plugins/actions/action.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1083 "action.c"
			gboolean _tmp39_ = FALSE;
#line 156 "../plugins/actions/action.vala"
			if (_inner_error0_->domain == G_SPAWN_ERROR) {
#line 1087 "action.c"
				goto __catch1_g_spawn_error;
			}
#line 156 "../plugins/actions/action.vala"
			_g_free0 (command);
#line 156 "../plugins/actions/action.vala"
			trigger_strings = (_vala_array_free (trigger_strings, trigger_strings_length1, (GDestroyNotify) g_free), NULL);
#line 156 "../plugins/actions/action.vala"
			spawn_args = (_vala_array_free (spawn_args, spawn_args_length1, (GDestroyNotify) g_free), NULL);
#line 156 "../plugins/actions/action.vala"
			spawn_env = (_vala_array_free (spawn_env, spawn_env_length1, (GDestroyNotify) g_free), NULL);
#line 156 "../plugins/actions/action.vala"
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 156 "../plugins/actions/action.vala"
			g_clear_error (&_inner_error0_);
#line 156 "../plugins/actions/action.vala"
			return _tmp39_;
#line 1104 "action.c"
		}
	}
	goto __finally1;
	__catch1_g_spawn_error:
	{
		GError* _error_ = NULL;
		FILE* _tmp40_;
		GError* _tmp41_;
		const gchar* _tmp42_;
#line 155 "../plugins/actions/action.vala"
		_error_ = _inner_error0_;
#line 155 "../plugins/actions/action.vala"
		_inner_error0_ = NULL;
#line 163 "../plugins/actions/action.vala"
		_tmp40_ = stdout;
#line 163 "../plugins/actions/action.vala"
		_tmp41_ = _error_;
#line 163 "../plugins/actions/action.vala"
		_tmp42_ = _tmp41_->message;
#line 163 "../plugins/actions/action.vala"
		fprintf (_tmp40_, "Error: %s\n", _tmp42_);
#line 164 "../plugins/actions/action.vala"
		result = FALSE;
#line 164 "../plugins/actions/action.vala"
		_g_error_free0 (_error_);
#line 164 "../plugins/actions/action.vala"
		_g_free0 (command);
#line 164 "../plugins/actions/action.vala"
		trigger_strings = (_vala_array_free (trigger_strings, trigger_strings_length1, (GDestroyNotify) g_free), NULL);
#line 164 "../plugins/actions/action.vala"
		spawn_args = (_vala_array_free (spawn_args, spawn_args_length1, (GDestroyNotify) g_free), NULL);
#line 164 "../plugins/actions/action.vala"
		spawn_env = (_vala_array_free (spawn_env, spawn_env_length1, (GDestroyNotify) g_free), NULL);
#line 164 "../plugins/actions/action.vala"
		return result;
#line 1140 "action.c"
	}
	__finally1:
#line 155 "../plugins/actions/action.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1145 "action.c"
		gboolean _tmp43_ = FALSE;
#line 155 "../plugins/actions/action.vala"
		_g_free0 (command);
#line 155 "../plugins/actions/action.vala"
		trigger_strings = (_vala_array_free (trigger_strings, trigger_strings_length1, (GDestroyNotify) g_free), NULL);
#line 155 "../plugins/actions/action.vala"
		spawn_args = (_vala_array_free (spawn_args, spawn_args_length1, (GDestroyNotify) g_free), NULL);
#line 155 "../plugins/actions/action.vala"
		spawn_env = (_vala_array_free (spawn_env, spawn_env_length1, (GDestroyNotify) g_free), NULL);
#line 155 "../plugins/actions/action.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 155 "../plugins/actions/action.vala"
		g_clear_error (&_inner_error0_);
#line 155 "../plugins/actions/action.vala"
		return _tmp43_;
#line 1161 "action.c"
	}
#line 167 "../plugins/actions/action.vala"
	result = TRUE;
#line 167 "../plugins/actions/action.vala"
	_g_free0 (command);
#line 167 "../plugins/actions/action.vala"
	trigger_strings = (_vala_array_free (trigger_strings, trigger_strings_length1, (GDestroyNotify) g_free), NULL);
#line 167 "../plugins/actions/action.vala"
	spawn_args = (_vala_array_free (spawn_args, spawn_args_length1, (GDestroyNotify) g_free), NULL);
#line 167 "../plugins/actions/action.vala"
	spawn_env = (_vala_array_free (spawn_env, spawn_env_length1, (GDestroyNotify) g_free), NULL);
#line 167 "../plugins/actions/action.vala"
	return result;
#line 1175 "action.c"
}

ActionsAction*
actions_action_construct (GType object_type)
{
	ActionsAction * self = NULL;
#line 24 "../plugins/actions/action.vala"
	self = (ActionsAction*) g_object_new (object_type, NULL);
#line 24 "../plugins/actions/action.vala"
	return self;
#line 1186 "action.c"
}

ActionsAction*
actions_action_new (void)
{
#line 24 "../plugins/actions/action.vala"
	return actions_action_construct (ACTIONS_TYPE_ACTION);
#line 1194 "action.c"
}

const gchar*
actions_action_get_name (ActionsAction* self)
{
	const gchar* result;
	const gchar* _tmp0_;
#line 26 "../plugins/actions/action.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 26 "../plugins/actions/action.vala"
	_tmp0_ = self->priv->_name;
#line 26 "../plugins/actions/action.vala"
	result = _tmp0_;
#line 26 "../plugins/actions/action.vala"
	return result;
#line 1210 "action.c"
}

void
actions_action_set_name (ActionsAction* self,
                         const gchar* value)
{
	gchar* old_value;
#line 26 "../plugins/actions/action.vala"
	g_return_if_fail (self != NULL);
#line 26 "../plugins/actions/action.vala"
	old_value = actions_action_get_name (self);
#line 26 "../plugins/actions/action.vala"
	if (g_strcmp0 (value, old_value) != 0) {
#line 1224 "action.c"
		gchar* _tmp0_;
#line 26 "../plugins/actions/action.vala"
		_tmp0_ = g_strdup (value);
#line 26 "../plugins/actions/action.vala"
		_g_free0 (self->priv->_name);
#line 26 "../plugins/actions/action.vala"
		self->priv->_name = _tmp0_;
#line 26 "../plugins/actions/action.vala"
		g_object_notify_by_pspec ((GObject *) self, actions_action_properties[ACTIONS_ACTION_NAME_PROPERTY]);
#line 1234 "action.c"
	}
}

const gchar*
actions_action_get_command (ActionsAction* self)
{
	const gchar* result;
	const gchar* _tmp0_;
#line 28 "../plugins/actions/action.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 29 "../plugins/actions/action.vala"
	_tmp0_ = self->priv->_command;
#line 29 "../plugins/actions/action.vala"
	result = _tmp0_;
#line 29 "../plugins/actions/action.vala"
	return result;
#line 1251 "action.c"
}

void
actions_action_set_command (ActionsAction* self,
                            const gchar* value)
{
	gchar* _tmp0_;
#line 31 "../plugins/actions/action.vala"
	g_return_if_fail (self != NULL);
#line 32 "../plugins/actions/action.vala"
	_tmp0_ = g_strdup (value);
#line 32 "../plugins/actions/action.vala"
	_g_free0 (self->priv->_command);
#line 32 "../plugins/actions/action.vala"
	self->priv->_command = _tmp0_;
#line 34 "../plugins/actions/action.vala"
	actions_action_validate_command (self);
#line 31 "../plugins/actions/action.vala"
	g_object_notify_by_pspec ((GObject *) self, actions_action_properties[ACTIONS_ACTION_COMMAND_PROPERTY]);
#line 1271 "action.c"
}

gchar*
actions_action_get_path (ActionsAction* self)
{
	gchar* result;
	gchar* _tmp0_ = NULL;
	GSettings* _tmp1_;
#line 38 "../plugins/actions/action.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 39 "../plugins/actions/action.vala"
	_tmp1_ = self->priv->settings;
#line 39 "../plugins/actions/action.vala"
	if (_tmp1_ != NULL) {
#line 1286 "action.c"
		GSettings* _tmp2_;
		gchar* _tmp3_;
		gchar* _tmp4_;
#line 39 "../plugins/actions/action.vala"
		_tmp2_ = self->priv->settings;
#line 39 "../plugins/actions/action.vala"
		g_object_get (_tmp2_, "path", &_tmp3_, NULL);
#line 39 "../plugins/actions/action.vala"
		_tmp4_ = _tmp3_;
#line 39 "../plugins/actions/action.vala"
		_g_free0 (_tmp0_);
#line 39 "../plugins/actions/action.vala"
		_tmp0_ = _tmp4_;
#line 1300 "action.c"
	} else {
#line 39 "../plugins/actions/action.vala"
		_g_free0 (_tmp0_);
#line 39 "../plugins/actions/action.vala"
		_tmp0_ = NULL;
#line 1306 "action.c"
	}
#line 39 "../plugins/actions/action.vala"
	result = _tmp0_;
#line 39 "../plugins/actions/action.vala"
	return result;
#line 1312 "action.c"
}

void
actions_action_set_path (ActionsAction* self,
                         const gchar* value)
{
#line 41 "../plugins/actions/action.vala"
	g_return_if_fail (self != NULL);
#line 42 "../plugins/actions/action.vala"
	if (value != NULL) {
#line 1323 "action.c"
		GSettings* _tmp0_;
		GSettings* _tmp1_;
		GSettings* _tmp2_;
		GSettings* _tmp3_;
		GSettings* _tmp4_;
#line 43 "../plugins/actions/action.vala"
		_tmp0_ = g_settings_new_with_path ("org.gnome.pomodoro.plugins.actions.action", value);
#line 43 "../plugins/actions/action.vala"
		_g_object_unref0 (self->priv->settings);
#line 43 "../plugins/actions/action.vala"
		self->priv->settings = _tmp0_;
#line 46 "../plugins/actions/action.vala"
		_tmp1_ = self->priv->settings;
#line 46 "../plugins/actions/action.vala"
		g_settings_bind (_tmp1_, "name", (GObject*) self, "name", G_SETTINGS_BIND_DEFAULT);
#line 50 "../plugins/actions/action.vala"
		_tmp2_ = self->priv->settings;
#line 50 "../plugins/actions/action.vala"
		g_settings_bind (_tmp2_, "command", (GObject*) self, "command", G_SETTINGS_BIND_DEFAULT);
#line 54 "../plugins/actions/action.vala"
		_tmp3_ = self->priv->settings;
#line 54 "../plugins/actions/action.vala"
		g_settings_bind (_tmp3_, "states", (GObject*) self, "states", G_SETTINGS_BIND_DEFAULT);
#line 58 "../plugins/actions/action.vala"
		_tmp4_ = self->priv->settings;
#line 58 "../plugins/actions/action.vala"
		g_settings_bind (_tmp4_, "triggers", (GObject*) self, "triggers", G_SETTINGS_BIND_DEFAULT);
#line 1351 "action.c"
	} else {
#line 64 "../plugins/actions/action.vala"
		_g_object_unref0 (self->priv->settings);
#line 64 "../plugins/actions/action.vala"
		self->priv->settings = NULL;
#line 1357 "action.c"
	}
#line 41 "../plugins/actions/action.vala"
	g_object_notify_by_pspec ((GObject *) self, actions_action_properties[ACTIONS_ACTION_PATH_PROPERTY]);
#line 1361 "action.c"
}

ActionsState
actions_action_get_states (ActionsAction* self)
{
	ActionsState result;
#line 68 "../plugins/actions/action.vala"
	g_return_val_if_fail (self != NULL, 0U);
#line 68 "../plugins/actions/action.vala"
	result = self->priv->_states;
#line 68 "../plugins/actions/action.vala"
	return result;
#line 1374 "action.c"
}

void
actions_action_set_states (ActionsAction* self,
                           ActionsState value)
{
	ActionsState old_value;
#line 68 "../plugins/actions/action.vala"
	g_return_if_fail (self != NULL);
#line 68 "../plugins/actions/action.vala"
	old_value = actions_action_get_states (self);
#line 68 "../plugins/actions/action.vala"
	if (old_value != value) {
#line 68 "../plugins/actions/action.vala"
		self->priv->_states = value;
#line 68 "../plugins/actions/action.vala"
		g_object_notify_by_pspec ((GObject *) self, actions_action_properties[ACTIONS_ACTION_STATES_PROPERTY]);
#line 1392 "action.c"
	}
}

ActionsTrigger
actions_action_get_triggers (ActionsAction* self)
{
	ActionsTrigger result;
#line 69 "../plugins/actions/action.vala"
	g_return_val_if_fail (self != NULL, 0U);
#line 69 "../plugins/actions/action.vala"
	result = self->priv->_triggers;
#line 69 "../plugins/actions/action.vala"
	return result;
#line 1406 "action.c"
}

void
actions_action_set_triggers (ActionsAction* self,
                             ActionsTrigger value)
{
	ActionsTrigger old_value;
#line 69 "../plugins/actions/action.vala"
	g_return_if_fail (self != NULL);
#line 69 "../plugins/actions/action.vala"
	old_value = actions_action_get_triggers (self);
#line 69 "../plugins/actions/action.vala"
	if (old_value != value) {
#line 69 "../plugins/actions/action.vala"
		self->priv->_triggers = value;
#line 69 "../plugins/actions/action.vala"
		g_object_notify_by_pspec ((GObject *) self, actions_action_properties[ACTIONS_ACTION_TRIGGERS_PROPERTY]);
#line 1424 "action.c"
	}
}

gboolean
actions_action_get_command_valid (ActionsAction* self)
{
	gboolean result;
#line 70 "../plugins/actions/action.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 70 "../plugins/actions/action.vala"
	result = self->priv->_command_valid;
#line 70 "../plugins/actions/action.vala"
	return result;
#line 1438 "action.c"
}

static void
actions_action_set_command_valid (ActionsAction* self,
                                  gboolean value)
{
	gboolean old_value;
#line 70 "../plugins/actions/action.vala"
	g_return_if_fail (self != NULL);
#line 70 "../plugins/actions/action.vala"
	old_value = actions_action_get_command_valid (self);
#line 70 "../plugins/actions/action.vala"
	if (old_value != value) {
#line 70 "../plugins/actions/action.vala"
		self->priv->_command_valid = value;
#line 70 "../plugins/actions/action.vala"
		g_object_notify_by_pspec ((GObject *) self, actions_action_properties[ACTIONS_ACTION_COMMAND_VALID_PROPERTY]);
#line 1456 "action.c"
	}
}

static void
actions_action_class_init (ActionsActionClass * klass,
                           gpointer klass_data)
{
#line 24 "../plugins/actions/action.vala"
	actions_action_parent_class = g_type_class_peek_parent (klass);
#line 24 "../plugins/actions/action.vala"
	g_type_class_adjust_private_offset (klass, &ActionsAction_private_offset);
#line 24 "../plugins/actions/action.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_actions_action_get_property;
#line 24 "../plugins/actions/action.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_actions_action_set_property;
#line 24 "../plugins/actions/action.vala"
	G_OBJECT_CLASS (klass)->finalize = actions_action_finalize;
#line 24 "../plugins/actions/action.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), ACTIONS_ACTION_NAME_PROPERTY, actions_action_properties[ACTIONS_ACTION_NAME_PROPERTY] = g_param_spec_string ("name", "name", "name", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 24 "../plugins/actions/action.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), ACTIONS_ACTION_COMMAND_PROPERTY, actions_action_properties[ACTIONS_ACTION_COMMAND_PROPERTY] = g_param_spec_string ("command", "command", "command", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 24 "../plugins/actions/action.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), ACTIONS_ACTION_PATH_PROPERTY, actions_action_properties[ACTIONS_ACTION_PATH_PROPERTY] = g_param_spec_string ("path", "path", "path", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT));
#line 24 "../plugins/actions/action.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), ACTIONS_ACTION_STATES_PROPERTY, actions_action_properties[ACTIONS_ACTION_STATES_PROPERTY] = g_param_spec_flags ("states", "states", "states", ACTIONS_TYPE_STATE, ACTIONS_STATE_ANY, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 24 "../plugins/actions/action.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), ACTIONS_ACTION_TRIGGERS_PROPERTY, actions_action_properties[ACTIONS_ACTION_TRIGGERS_PROPERTY] = g_param_spec_flags ("triggers", "triggers", "triggers", ACTIONS_TYPE_TRIGGER, ACTIONS_TRIGGER_NONE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 24 "../plugins/actions/action.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), ACTIONS_ACTION_COMMAND_VALID_PROPERTY, actions_action_properties[ACTIONS_ACTION_COMMAND_VALID_PROPERTY] = g_param_spec_boolean ("command-valid", "command-valid", "command-valid", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 1486 "action.c"
}

static void
actions_action_instance_init (ActionsAction * self,
                              gpointer klass)
{
#line 24 "../plugins/actions/action.vala"
	self->priv = actions_action_get_instance_private (self);
#line 68 "../plugins/actions/action.vala"
	self->priv->_states = ACTIONS_STATE_ANY;
#line 69 "../plugins/actions/action.vala"
	self->priv->_triggers = ACTIONS_TRIGGER_NONE;
#line 70 "../plugins/actions/action.vala"
	self->priv->_command_valid = FALSE;
#line 1501 "action.c"
}

static void
actions_action_finalize (GObject * obj)
{
	ActionsAction * self;
#line 24 "../plugins/actions/action.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, ACTIONS_TYPE_ACTION, ActionsAction);
#line 26 "../plugins/actions/action.vala"
	_g_free0 (self->priv->_name);
#line 72 "../plugins/actions/action.vala"
	_g_free0 (self->priv->_command);
#line 73 "../plugins/actions/action.vala"
	_g_object_unref0 (self->priv->settings);
#line 74 "../plugins/actions/action.vala"
	_g_object_unref0 (self->priv->remove_action);
#line 24 "../plugins/actions/action.vala"
	G_OBJECT_CLASS (actions_action_parent_class)->finalize (obj);
#line 1520 "action.c"
}

GType
actions_action_get_type (void)
{
	return actions_action_type_id;
}

GType
actions_action_register_type (GTypeModule * module)
{
	static const GTypeInfo g_define_type_info = { sizeof (ActionsActionClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) actions_action_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (ActionsAction), 0, (GInstanceInitFunc) actions_action_instance_init, NULL };
	actions_action_type_id = g_type_module_register_type (module, G_TYPE_OBJECT, "ActionsAction", &g_define_type_info, 0);
	ActionsAction_private_offset = sizeof (ActionsActionPrivate);
	return actions_action_type_id;
}

static void
_vala_actions_action_get_property (GObject * object,
                                   guint property_id,
                                   GValue * value,
                                   GParamSpec * pspec)
{
	ActionsAction * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, ACTIONS_TYPE_ACTION, ActionsAction);
#line 24 "../plugins/actions/action.vala"
	switch (property_id) {
#line 24 "../plugins/actions/action.vala"
		case ACTIONS_ACTION_NAME_PROPERTY:
#line 24 "../plugins/actions/action.vala"
		g_value_set_string (value, actions_action_get_name (self));
#line 24 "../plugins/actions/action.vala"
		break;
#line 24 "../plugins/actions/action.vala"
		case ACTIONS_ACTION_COMMAND_PROPERTY:
#line 24 "../plugins/actions/action.vala"
		g_value_set_string (value, actions_action_get_command (self));
#line 24 "../plugins/actions/action.vala"
		break;
#line 24 "../plugins/actions/action.vala"
		case ACTIONS_ACTION_PATH_PROPERTY:
#line 24 "../plugins/actions/action.vala"
		g_value_take_string (value, actions_action_get_path (self));
#line 24 "../plugins/actions/action.vala"
		break;
#line 24 "../plugins/actions/action.vala"
		case ACTIONS_ACTION_STATES_PROPERTY:
#line 24 "../plugins/actions/action.vala"
		g_value_set_flags (value, actions_action_get_states (self));
#line 24 "../plugins/actions/action.vala"
		break;
#line 24 "../plugins/actions/action.vala"
		case ACTIONS_ACTION_TRIGGERS_PROPERTY:
#line 24 "../plugins/actions/action.vala"
		g_value_set_flags (value, actions_action_get_triggers (self));
#line 24 "../plugins/actions/action.vala"
		break;
#line 24 "../plugins/actions/action.vala"
		case ACTIONS_ACTION_COMMAND_VALID_PROPERTY:
#line 24 "../plugins/actions/action.vala"
		g_value_set_boolean (value, actions_action_get_command_valid (self));
#line 24 "../plugins/actions/action.vala"
		break;
#line 1584 "action.c"
		default:
#line 24 "../plugins/actions/action.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 24 "../plugins/actions/action.vala"
		break;
#line 1590 "action.c"
	}
}

static void
_vala_actions_action_set_property (GObject * object,
                                   guint property_id,
                                   const GValue * value,
                                   GParamSpec * pspec)
{
	ActionsAction * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, ACTIONS_TYPE_ACTION, ActionsAction);
#line 24 "../plugins/actions/action.vala"
	switch (property_id) {
#line 24 "../plugins/actions/action.vala"
		case ACTIONS_ACTION_NAME_PROPERTY:
#line 24 "../plugins/actions/action.vala"
		actions_action_set_name (self, g_value_get_string (value));
#line 24 "../plugins/actions/action.vala"
		break;
#line 24 "../plugins/actions/action.vala"
		case ACTIONS_ACTION_COMMAND_PROPERTY:
#line 24 "../plugins/actions/action.vala"
		actions_action_set_command (self, g_value_get_string (value));
#line 24 "../plugins/actions/action.vala"
		break;
#line 24 "../plugins/actions/action.vala"
		case ACTIONS_ACTION_PATH_PROPERTY:
#line 24 "../plugins/actions/action.vala"
		actions_action_set_path (self, g_value_get_string (value));
#line 24 "../plugins/actions/action.vala"
		break;
#line 24 "../plugins/actions/action.vala"
		case ACTIONS_ACTION_STATES_PROPERTY:
#line 24 "../plugins/actions/action.vala"
		actions_action_set_states (self, g_value_get_flags (value));
#line 24 "../plugins/actions/action.vala"
		break;
#line 24 "../plugins/actions/action.vala"
		case ACTIONS_ACTION_TRIGGERS_PROPERTY:
#line 24 "../plugins/actions/action.vala"
		actions_action_set_triggers (self, g_value_get_flags (value));
#line 24 "../plugins/actions/action.vala"
		break;
#line 24 "../plugins/actions/action.vala"
		case ACTIONS_ACTION_COMMAND_VALID_PROPERTY:
#line 24 "../plugins/actions/action.vala"
		actions_action_set_command_valid (self, g_value_get_boolean (value));
#line 24 "../plugins/actions/action.vala"
		break;
#line 1640 "action.c"
		default:
#line 24 "../plugins/actions/action.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 24 "../plugins/actions/action.vala"
		break;
#line 1646 "action.c"
	}
}

static void
_vala_array_destroy (gpointer array,
                     gssize array_length,
                     GDestroyNotify destroy_func)
{
	if ((array != NULL) && (destroy_func != NULL)) {
		gssize i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}

static void
_vala_array_free (gpointer array,
                  gssize array_length,
                  GDestroyNotify destroy_func)
{
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}

static gssize
_vala_array_length (gpointer array)
{
	gssize length;
	length = 0;
	if (array) {
		while (((gpointer*) array)[length]) {
			length++;
		}
	}
	return length;
}

