/* timer-state.c generated by valac 0.56.9, the Vala compiler
 * generated from timer-state.vala, do not modify */

/*
 * Copyright (c) 2011-2015 gnome-pomodoro contributors
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 * Authors: Arun Mahapatra <pratikarun@gmail.com>
 *          Kamil Prusko <kamilprusko@gmail.com>
 */

#include <glib.h>
#include <float.h>
#include <math.h>
#include "gnome-pomodoro.h"
#include <stdlib.h>
#include <string.h>
#include <glib-object.h>
#include <gio/gio.h>

#define POMODORO_MIN_POMODORO_TIME 60.0
#define POMODORO_POMODORO_THRESHOLD 0.90
#define POMODORO_MISSING_SCORE_THRESHOLD 0.50
#define POMODORO_SHORT_TO_LONG_BREAK_THRESHOLD 0.50
#define POMODORO_TIME_TO_RESET_SCORE 3600.0

enum  {
	POMODORO_TIMER_STATE_0_PROPERTY,
	POMODORO_TIMER_STATE_NAME_PROPERTY,
	POMODORO_TIMER_STATE_ELAPSED_PROPERTY,
	POMODORO_TIMER_STATE_DURATION_PROPERTY,
	POMODORO_TIMER_STATE_TIMESTAMP_PROPERTY,
	POMODORO_TIMER_STATE_NUM_PROPERTIES
};
static GParamSpec* pomodoro_timer_state_properties[POMODORO_TIMER_STATE_NUM_PROPERTIES];
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
enum  {
	POMODORO_DISABLED_STATE_0_PROPERTY,
	POMODORO_DISABLED_STATE_NUM_PROPERTIES
};
static GParamSpec* pomodoro_disabled_state_properties[POMODORO_DISABLED_STATE_NUM_PROPERTIES];
enum  {
	POMODORO_POMODORO_STATE_0_PROPERTY,
	POMODORO_POMODORO_STATE_NUM_PROPERTIES
};
static GParamSpec* pomodoro_pomodoro_state_properties[POMODORO_POMODORO_STATE_NUM_PROPERTIES];
enum  {
	POMODORO_BREAK_STATE_0_PROPERTY,
	POMODORO_BREAK_STATE_NUM_PROPERTIES
};
static GParamSpec* pomodoro_break_state_properties[POMODORO_BREAK_STATE_NUM_PROPERTIES];
enum  {
	POMODORO_SHORT_BREAK_STATE_0_PROPERTY,
	POMODORO_SHORT_BREAK_STATE_NUM_PROPERTIES
};
static GParamSpec* pomodoro_short_break_state_properties[POMODORO_SHORT_BREAK_STATE_NUM_PROPERTIES];
enum  {
	POMODORO_LONG_BREAK_STATE_0_PROPERTY,
	POMODORO_LONG_BREAK_STATE_NUM_PROPERTIES
};
static GParamSpec* pomodoro_long_break_state_properties[POMODORO_LONG_BREAK_STATE_NUM_PROPERTIES];

struct _PomodoroTimerStatePrivate {
	gchar* _name;
	gdouble _elapsed;
	gdouble _duration;
	gdouble _timestamp;
};

static gint PomodoroTimerState_private_offset;
static gpointer pomodoro_timer_state_parent_class = NULL;
static gpointer pomodoro_disabled_state_parent_class = NULL;
static gpointer pomodoro_pomodoro_state_parent_class = NULL;
static gpointer pomodoro_break_state_parent_class = NULL;
static gpointer pomodoro_short_break_state_parent_class = NULL;
static gpointer pomodoro_long_break_state_parent_class = NULL;

static PomodoroTimerState* pomodoro_timer_state_real_create_next_state (PomodoroTimerState* self,
                                                                 gdouble score,
                                                                 gdouble timestamp);
static gdouble pomodoro_timer_state_real_calculate_score (PomodoroTimerState* self,
                                                   gdouble score,
                                                   gdouble timestamp);
static GObject * pomodoro_timer_state_constructor (GType type,
                                            guint n_construct_properties,
                                            GObjectConstructParam * construct_properties);
static void pomodoro_timer_state_finalize (GObject * obj);
static GType pomodoro_timer_state_get_type_once (void);
static void _vala_pomodoro_timer_state_get_property (GObject * object,
                                              guint property_id,
                                              GValue * value,
                                              GParamSpec * pspec);
static void _vala_pomodoro_timer_state_set_property (GObject * object,
                                              guint property_id,
                                              const GValue * value,
                                              GParamSpec * pspec);
static PomodoroTimerState* pomodoro_disabled_state_real_create_next_state (PomodoroTimerState* base,
                                                                    gdouble score,
                                                                    gdouble timestamp);
static gdouble pomodoro_disabled_state_real_calculate_score (PomodoroTimerState* base,
                                                      gdouble score,
                                                      gdouble timestamp);
static GObject * pomodoro_disabled_state_constructor (GType type,
                                               guint n_construct_properties,
                                               GObjectConstructParam * construct_properties);
static GType pomodoro_disabled_state_get_type_once (void);
static PomodoroTimerState* pomodoro_pomodoro_state_real_create_next_state (PomodoroTimerState* base,
                                                                    gdouble score,
                                                                    gdouble timestamp);
static gdouble pomodoro_pomodoro_state_real_calculate_score (PomodoroTimerState* base,
                                                      gdouble score,
                                                      gdouble timestamp);
static GObject * pomodoro_pomodoro_state_constructor (GType type,
                                               guint n_construct_properties,
                                               GObjectConstructParam * construct_properties);
static GType pomodoro_pomodoro_state_get_type_once (void);
static PomodoroTimerState* pomodoro_break_state_real_create_next_state (PomodoroTimerState* base,
                                                                 gdouble score,
                                                                 gdouble timestamp);
static GType pomodoro_break_state_get_type_once (void);
static GObject * pomodoro_short_break_state_constructor (GType type,
                                                  guint n_construct_properties,
                                                  GObjectConstructParam * construct_properties);
static GType pomodoro_short_break_state_get_type_once (void);
static gdouble pomodoro_long_break_state_real_calculate_score (PomodoroTimerState* base,
                                                        gdouble score,
                                                        gdouble timestamp);
static GObject * pomodoro_long_break_state_constructor (GType type,
                                                 guint n_construct_properties,
                                                 GObjectConstructParam * construct_properties);
static GType pomodoro_long_break_state_get_type_once (void);

static inline gpointer
pomodoro_timer_state_get_instance_private (PomodoroTimerState* self)
{
	return G_STRUCT_MEMBER_P (self, PomodoroTimerState_private_offset);
}

static PomodoroTimerState*
pomodoro_timer_state_real_create_next_state (PomodoroTimerState* self,
                                             gdouble score,
                                             gdouble timestamp)
{
#line 53 "../src/timer-state.vala"
	g_critical ("Type `%s' does not implement abstract method `pomodoro_timer_state_create_next_state'", g_type_name (G_TYPE_FROM_INSTANCE (self)));
#line 53 "../src/timer-state.vala"
	return NULL;
#line 162 "timer-state.c"
}

PomodoroTimerState*
pomodoro_timer_state_create_next_state (PomodoroTimerState* self,
                                        gdouble score,
                                        gdouble timestamp)
{
	PomodoroTimerStateClass* _klass_;
#line 53 "../src/timer-state.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 53 "../src/timer-state.vala"
	_klass_ = POMODORO_TIMER_STATE_GET_CLASS (self);
#line 53 "../src/timer-state.vala"
	if (_klass_->create_next_state) {
#line 53 "../src/timer-state.vala"
		return _klass_->create_next_state (self, score, timestamp);
#line 179 "timer-state.c"
	}
#line 53 "../src/timer-state.vala"
	return NULL;
#line 183 "timer-state.c"
}

/**
         * Returns acumulated score, or 0.0 if taken a long break.
         */
static gdouble
pomodoro_timer_state_real_calculate_score (PomodoroTimerState* self,
                                           gdouble score,
                                           gdouble timestamp)
{
	gdouble result;
#line 62 "../src/timer-state.vala"
	result = score;
#line 62 "../src/timer-state.vala"
	return result;
#line 199 "timer-state.c"
}

gdouble
pomodoro_timer_state_calculate_score (PomodoroTimerState* self,
                                      gdouble score,
                                      gdouble timestamp)
{
	PomodoroTimerStateClass* _klass_;
#line 59 "../src/timer-state.vala"
	g_return_val_if_fail (self != NULL, 0.0);
#line 59 "../src/timer-state.vala"
	_klass_ = POMODORO_TIMER_STATE_GET_CLASS (self);
#line 59 "../src/timer-state.vala"
	if (_klass_->calculate_score) {
#line 59 "../src/timer-state.vala"
		return _klass_->calculate_score (self, score, timestamp);
#line 216 "timer-state.c"
	}
#line 59 "../src/timer-state.vala"
	return -1.0;
#line 220 "timer-state.c"
}

PomodoroTimerState*
pomodoro_timer_state_lookup (const gchar* name)
{
	PomodoroTimerState* state = NULL;
	const gchar* _tmp0_;
	GQuark _tmp2_ = 0U;
#line 69 "../src/timer-state.vala"
	static GQuark _tmp1_label0 = 0;
#line 69 "../src/timer-state.vala"
	static GQuark _tmp1_label1 = 0;
#line 69 "../src/timer-state.vala"
	static GQuark _tmp1_label2 = 0;
#line 69 "../src/timer-state.vala"
	static GQuark _tmp1_label3 = 0;
#line 237 "timer-state.c"
	PomodoroTimerState* result;
#line 65 "../src/timer-state.vala"
	g_return_val_if_fail (name != NULL, NULL);
#line 69 "../src/timer-state.vala"
	_tmp0_ = name;
#line 69 "../src/timer-state.vala"
	_tmp2_ = (NULL == _tmp0_) ? 0 : g_quark_from_string (_tmp0_);
#line 69 "../src/timer-state.vala"
	if (_tmp2_ == ((0 != _tmp1_label0) ? _tmp1_label0 : (_tmp1_label0 = g_quark_from_static_string ("pomodoro")))) {
#line 69 "../src/timer-state.vala"
		switch (0) {
#line 249 "timer-state.c"
			default:
			{
				PomodoroPomodoroState* _tmp3_;
#line 72 "../src/timer-state.vala"
				_tmp3_ = pomodoro_pomodoro_state_new ();
#line 72 "../src/timer-state.vala"
				_g_object_unref0 (state);
#line 72 "../src/timer-state.vala"
				state = (PomodoroTimerState*) _tmp3_;
#line 73 "../src/timer-state.vala"
				break;
#line 261 "timer-state.c"
			}
		}
	} else if (_tmp2_ == ((0 != _tmp1_label1) ? _tmp1_label1 : (_tmp1_label1 = g_quark_from_static_string ("short-break")))) {
#line 69 "../src/timer-state.vala"
		switch (0) {
#line 267 "timer-state.c"
			default:
			{
				PomodoroShortBreakState* _tmp4_;
#line 76 "../src/timer-state.vala"
				_tmp4_ = pomodoro_short_break_state_new ();
#line 76 "../src/timer-state.vala"
				_g_object_unref0 (state);
#line 76 "../src/timer-state.vala"
				state = (PomodoroTimerState*) _tmp4_;
#line 77 "../src/timer-state.vala"
				break;
#line 279 "timer-state.c"
			}
		}
	} else if (_tmp2_ == ((0 != _tmp1_label2) ? _tmp1_label2 : (_tmp1_label2 = g_quark_from_static_string ("long-break")))) {
#line 69 "../src/timer-state.vala"
		switch (0) {
#line 285 "timer-state.c"
			default:
			{
				PomodoroLongBreakState* _tmp5_;
#line 80 "../src/timer-state.vala"
				_tmp5_ = pomodoro_long_break_state_new ();
#line 80 "../src/timer-state.vala"
				_g_object_unref0 (state);
#line 80 "../src/timer-state.vala"
				state = (PomodoroTimerState*) _tmp5_;
#line 81 "../src/timer-state.vala"
				break;
#line 297 "timer-state.c"
			}
		}
	} else if (_tmp2_ == ((0 != _tmp1_label3) ? _tmp1_label3 : (_tmp1_label3 = g_quark_from_static_string ("null")))) {
#line 69 "../src/timer-state.vala"
		switch (0) {
#line 303 "timer-state.c"
			default:
			{
				PomodoroDisabledState* _tmp6_;
#line 84 "../src/timer-state.vala"
				_tmp6_ = pomodoro_disabled_state_new ();
#line 84 "../src/timer-state.vala"
				_g_object_unref0 (state);
#line 84 "../src/timer-state.vala"
				state = (PomodoroTimerState*) _tmp6_;
#line 85 "../src/timer-state.vala"
				break;
#line 315 "timer-state.c"
			}
		}
	} else {
#line 69 "../src/timer-state.vala"
		switch (0) {
#line 321 "timer-state.c"
			default:
			{
#line 88 "../src/timer-state.vala"
				_g_object_unref0 (state);
#line 88 "../src/timer-state.vala"
				state = NULL;
#line 89 "../src/timer-state.vala"
				break;
#line 330 "timer-state.c"
			}
		}
	}
#line 92 "../src/timer-state.vala"
	result = state;
#line 92 "../src/timer-state.vala"
	return result;
#line 338 "timer-state.c"
}

gboolean
pomodoro_timer_state_is_completed (PomodoroTimerState* self)
{
	gdouble _tmp0_;
	gdouble _tmp1_;
	gboolean result;
#line 95 "../src/timer-state.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 97 "../src/timer-state.vala"
	_tmp0_ = self->priv->_elapsed;
#line 97 "../src/timer-state.vala"
	_tmp1_ = self->priv->_duration;
#line 97 "../src/timer-state.vala"
	result = _tmp0_ >= _tmp1_;
#line 97 "../src/timer-state.vala"
	return result;
#line 357 "timer-state.c"
}

PomodoroTimerState*
pomodoro_timer_state_construct (GType object_type)
{
	PomodoroTimerState * self = NULL;
#line 41 "../src/timer-state.vala"
	self = (PomodoroTimerState*) g_object_new (object_type, NULL);
#line 41 "../src/timer-state.vala"
	return self;
#line 368 "timer-state.c"
}

const gchar*
pomodoro_timer_state_get_name (PomodoroTimerState* self)
{
	const gchar* result;
	const gchar* _tmp0_;
#line 43 "../src/timer-state.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 43 "../src/timer-state.vala"
	_tmp0_ = self->priv->_name;
#line 43 "../src/timer-state.vala"
	result = _tmp0_;
#line 43 "../src/timer-state.vala"
	return result;
#line 384 "timer-state.c"
}

void
pomodoro_timer_state_set_name (PomodoroTimerState* self,
                               const gchar* value)
{
	gchar* old_value;
#line 43 "../src/timer-state.vala"
	g_return_if_fail (self != NULL);
#line 43 "../src/timer-state.vala"
	old_value = pomodoro_timer_state_get_name (self);
#line 43 "../src/timer-state.vala"
	if (g_strcmp0 (value, old_value) != 0) {
#line 398 "timer-state.c"
		gchar* _tmp0_;
#line 43 "../src/timer-state.vala"
		_tmp0_ = g_strdup (value);
#line 43 "../src/timer-state.vala"
		_g_free0 (self->priv->_name);
#line 43 "../src/timer-state.vala"
		self->priv->_name = _tmp0_;
#line 43 "../src/timer-state.vala"
		g_object_notify_by_pspec ((GObject *) self, pomodoro_timer_state_properties[POMODORO_TIMER_STATE_NAME_PROPERTY]);
#line 408 "timer-state.c"
	}
}

gdouble
pomodoro_timer_state_get_elapsed (PomodoroTimerState* self)
{
	gdouble result;
#line 44 "../src/timer-state.vala"
	g_return_val_if_fail (self != NULL, 0.0);
#line 44 "../src/timer-state.vala"
	result = self->priv->_elapsed;
#line 44 "../src/timer-state.vala"
	return result;
#line 422 "timer-state.c"
}

void
pomodoro_timer_state_set_elapsed (PomodoroTimerState* self,
                                  gdouble value)
{
	gdouble old_value;
#line 44 "../src/timer-state.vala"
	g_return_if_fail (self != NULL);
#line 44 "../src/timer-state.vala"
	old_value = pomodoro_timer_state_get_elapsed (self);
#line 44 "../src/timer-state.vala"
	if (old_value != value) {
#line 44 "../src/timer-state.vala"
		self->priv->_elapsed = value;
#line 44 "../src/timer-state.vala"
		g_object_notify_by_pspec ((GObject *) self, pomodoro_timer_state_properties[POMODORO_TIMER_STATE_ELAPSED_PROPERTY]);
#line 440 "timer-state.c"
	}
}

gdouble
pomodoro_timer_state_get_duration (PomodoroTimerState* self)
{
	gdouble result;
#line 45 "../src/timer-state.vala"
	g_return_val_if_fail (self != NULL, 0.0);
#line 45 "../src/timer-state.vala"
	result = self->priv->_duration;
#line 45 "../src/timer-state.vala"
	return result;
#line 454 "timer-state.c"
}

void
pomodoro_timer_state_set_duration (PomodoroTimerState* self,
                                   gdouble value)
{
	gdouble old_value;
#line 45 "../src/timer-state.vala"
	g_return_if_fail (self != NULL);
#line 45 "../src/timer-state.vala"
	old_value = pomodoro_timer_state_get_duration (self);
#line 45 "../src/timer-state.vala"
	if (old_value != value) {
#line 45 "../src/timer-state.vala"
		self->priv->_duration = value;
#line 45 "../src/timer-state.vala"
		g_object_notify_by_pspec ((GObject *) self, pomodoro_timer_state_properties[POMODORO_TIMER_STATE_DURATION_PROPERTY]);
#line 472 "timer-state.c"
	}
}

gdouble
pomodoro_timer_state_get_timestamp (PomodoroTimerState* self)
{
	gdouble result;
#line 46 "../src/timer-state.vala"
	g_return_val_if_fail (self != NULL, 0.0);
#line 46 "../src/timer-state.vala"
	result = self->priv->_timestamp;
#line 46 "../src/timer-state.vala"
	return result;
#line 486 "timer-state.c"
}

void
pomodoro_timer_state_set_timestamp (PomodoroTimerState* self,
                                    gdouble value)
{
	gdouble old_value;
#line 46 "../src/timer-state.vala"
	g_return_if_fail (self != NULL);
#line 46 "../src/timer-state.vala"
	old_value = pomodoro_timer_state_get_timestamp (self);
#line 46 "../src/timer-state.vala"
	if (old_value != value) {
#line 46 "../src/timer-state.vala"
		self->priv->_timestamp = value;
#line 46 "../src/timer-state.vala"
		g_object_notify_by_pspec ((GObject *) self, pomodoro_timer_state_properties[POMODORO_TIMER_STATE_TIMESTAMP_PROPERTY]);
#line 504 "timer-state.c"
	}
}

static GObject *
pomodoro_timer_state_constructor (GType type,
                                  guint n_construct_properties,
                                  GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	PomodoroTimerState * self;
#line 48 "../src/timer-state.vala"
	parent_class = G_OBJECT_CLASS (pomodoro_timer_state_parent_class);
#line 48 "../src/timer-state.vala"
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
#line 48 "../src/timer-state.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, POMODORO_TYPE_TIMER_STATE, PomodoroTimerState);
#line 50 "../src/timer-state.vala"
	pomodoro_timer_state_set_timestamp (self, pomodoro_get_current_time ());
#line 48 "../src/timer-state.vala"
	return obj;
#line 526 "timer-state.c"
}

static void
pomodoro_timer_state_class_init (PomodoroTimerStateClass * klass,
                                 gpointer klass_data)
{
#line 41 "../src/timer-state.vala"
	pomodoro_timer_state_parent_class = g_type_class_peek_parent (klass);
#line 41 "../src/timer-state.vala"
	g_type_class_adjust_private_offset (klass, &PomodoroTimerState_private_offset);
#line 41 "../src/timer-state.vala"
	((PomodoroTimerStateClass *) klass)->create_next_state = (PomodoroTimerState* (*) (PomodoroTimerState*, gdouble, gdouble)) pomodoro_timer_state_real_create_next_state;
#line 41 "../src/timer-state.vala"
	((PomodoroTimerStateClass *) klass)->calculate_score = (gdouble (*) (PomodoroTimerState*, gdouble, gdouble)) pomodoro_timer_state_real_calculate_score;
#line 41 "../src/timer-state.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_pomodoro_timer_state_get_property;
#line 41 "../src/timer-state.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_pomodoro_timer_state_set_property;
#line 41 "../src/timer-state.vala"
	G_OBJECT_CLASS (klass)->constructor = pomodoro_timer_state_constructor;
#line 41 "../src/timer-state.vala"
	G_OBJECT_CLASS (klass)->finalize = pomodoro_timer_state_finalize;
#line 41 "../src/timer-state.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), POMODORO_TIMER_STATE_NAME_PROPERTY, pomodoro_timer_state_properties[POMODORO_TIMER_STATE_NAME_PROPERTY] = g_param_spec_string ("name", "name", "name", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT));
#line 41 "../src/timer-state.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), POMODORO_TIMER_STATE_ELAPSED_PROPERTY, pomodoro_timer_state_properties[POMODORO_TIMER_STATE_ELAPSED_PROPERTY] = g_param_spec_double ("elapsed", "elapsed", "elapsed", -G_MAXDOUBLE, G_MAXDOUBLE, 0.0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 41 "../src/timer-state.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), POMODORO_TIMER_STATE_DURATION_PROPERTY, pomodoro_timer_state_properties[POMODORO_TIMER_STATE_DURATION_PROPERTY] = g_param_spec_double ("duration", "duration", "duration", -G_MAXDOUBLE, G_MAXDOUBLE, 0.0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 41 "../src/timer-state.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), POMODORO_TIMER_STATE_TIMESTAMP_PROPERTY, pomodoro_timer_state_properties[POMODORO_TIMER_STATE_TIMESTAMP_PROPERTY] = g_param_spec_double ("timestamp", "timestamp", "timestamp", -G_MAXDOUBLE, G_MAXDOUBLE, 0.0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT));
#line 557 "timer-state.c"
}

static void
pomodoro_timer_state_instance_init (PomodoroTimerState * self,
                                    gpointer klass)
{
#line 41 "../src/timer-state.vala"
	self->priv = pomodoro_timer_state_get_instance_private (self);
#line 44 "../src/timer-state.vala"
	self->priv->_elapsed = 0.0;
#line 45 "../src/timer-state.vala"
	self->priv->_duration = 0.0;
#line 570 "timer-state.c"
}

static void
pomodoro_timer_state_finalize (GObject * obj)
{
	PomodoroTimerState * self;
#line 41 "../src/timer-state.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, POMODORO_TYPE_TIMER_STATE, PomodoroTimerState);
#line 43 "../src/timer-state.vala"
	_g_free0 (self->priv->_name);
#line 41 "../src/timer-state.vala"
	G_OBJECT_CLASS (pomodoro_timer_state_parent_class)->finalize (obj);
#line 583 "timer-state.c"
}

static GType
pomodoro_timer_state_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (PomodoroTimerStateClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) pomodoro_timer_state_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (PomodoroTimerState), 0, (GInstanceInitFunc) pomodoro_timer_state_instance_init, NULL };
	GType pomodoro_timer_state_type_id;
	pomodoro_timer_state_type_id = g_type_register_static (G_TYPE_OBJECT, "PomodoroTimerState", &g_define_type_info, G_TYPE_FLAG_ABSTRACT);
	PomodoroTimerState_private_offset = g_type_add_instance_private (pomodoro_timer_state_type_id, sizeof (PomodoroTimerStatePrivate));
	return pomodoro_timer_state_type_id;
}

GType
pomodoro_timer_state_get_type (void)
{
	static volatile gsize pomodoro_timer_state_type_id__once = 0;
	if (g_once_init_enter (&pomodoro_timer_state_type_id__once)) {
		GType pomodoro_timer_state_type_id;
		pomodoro_timer_state_type_id = pomodoro_timer_state_get_type_once ();
		g_once_init_leave (&pomodoro_timer_state_type_id__once, pomodoro_timer_state_type_id);
	}
	return pomodoro_timer_state_type_id__once;
}

static void
_vala_pomodoro_timer_state_get_property (GObject * object,
                                         guint property_id,
                                         GValue * value,
                                         GParamSpec * pspec)
{
	PomodoroTimerState * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, POMODORO_TYPE_TIMER_STATE, PomodoroTimerState);
#line 41 "../src/timer-state.vala"
	switch (property_id) {
#line 41 "../src/timer-state.vala"
		case POMODORO_TIMER_STATE_NAME_PROPERTY:
#line 41 "../src/timer-state.vala"
		g_value_set_string (value, pomodoro_timer_state_get_name (self));
#line 41 "../src/timer-state.vala"
		break;
#line 41 "../src/timer-state.vala"
		case POMODORO_TIMER_STATE_ELAPSED_PROPERTY:
#line 41 "../src/timer-state.vala"
		g_value_set_double (value, pomodoro_timer_state_get_elapsed (self));
#line 41 "../src/timer-state.vala"
		break;
#line 41 "../src/timer-state.vala"
		case POMODORO_TIMER_STATE_DURATION_PROPERTY:
#line 41 "../src/timer-state.vala"
		g_value_set_double (value, pomodoro_timer_state_get_duration (self));
#line 41 "../src/timer-state.vala"
		break;
#line 41 "../src/timer-state.vala"
		case POMODORO_TIMER_STATE_TIMESTAMP_PROPERTY:
#line 41 "../src/timer-state.vala"
		g_value_set_double (value, pomodoro_timer_state_get_timestamp (self));
#line 41 "../src/timer-state.vala"
		break;
#line 642 "timer-state.c"
		default:
#line 41 "../src/timer-state.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 41 "../src/timer-state.vala"
		break;
#line 648 "timer-state.c"
	}
}

static void
_vala_pomodoro_timer_state_set_property (GObject * object,
                                         guint property_id,
                                         const GValue * value,
                                         GParamSpec * pspec)
{
	PomodoroTimerState * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, POMODORO_TYPE_TIMER_STATE, PomodoroTimerState);
#line 41 "../src/timer-state.vala"
	switch (property_id) {
#line 41 "../src/timer-state.vala"
		case POMODORO_TIMER_STATE_NAME_PROPERTY:
#line 41 "../src/timer-state.vala"
		pomodoro_timer_state_set_name (self, g_value_get_string (value));
#line 41 "../src/timer-state.vala"
		break;
#line 41 "../src/timer-state.vala"
		case POMODORO_TIMER_STATE_ELAPSED_PROPERTY:
#line 41 "../src/timer-state.vala"
		pomodoro_timer_state_set_elapsed (self, g_value_get_double (value));
#line 41 "../src/timer-state.vala"
		break;
#line 41 "../src/timer-state.vala"
		case POMODORO_TIMER_STATE_DURATION_PROPERTY:
#line 41 "../src/timer-state.vala"
		pomodoro_timer_state_set_duration (self, g_value_get_double (value));
#line 41 "../src/timer-state.vala"
		break;
#line 41 "../src/timer-state.vala"
		case POMODORO_TIMER_STATE_TIMESTAMP_PROPERTY:
#line 41 "../src/timer-state.vala"
		pomodoro_timer_state_set_timestamp (self, g_value_get_double (value));
#line 41 "../src/timer-state.vala"
		break;
#line 686 "timer-state.c"
		default:
#line 41 "../src/timer-state.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 41 "../src/timer-state.vala"
		break;
#line 692 "timer-state.c"
	}
}

PomodoroDisabledState*
pomodoro_disabled_state_construct_with_timestamp (GType object_type,
                                                  gdouble timestamp)
{
	PomodoroDisabledState * self = NULL;
#line 108 "../src/timer-state.vala"
	self = (PomodoroDisabledState*) pomodoro_timer_state_construct (object_type);
#line 110 "../src/timer-state.vala"
	pomodoro_timer_state_set_timestamp ((PomodoroTimerState*) self, timestamp);
#line 108 "../src/timer-state.vala"
	return self;
#line 707 "timer-state.c"
}

PomodoroDisabledState*
pomodoro_disabled_state_new_with_timestamp (gdouble timestamp)
{
#line 108 "../src/timer-state.vala"
	return pomodoro_disabled_state_construct_with_timestamp (POMODORO_TYPE_DISABLED_STATE, timestamp);
#line 715 "timer-state.c"
}

static PomodoroTimerState*
pomodoro_disabled_state_real_create_next_state (PomodoroTimerState* base,
                                                gdouble score,
                                                gdouble timestamp)
{
	PomodoroDisabledState * self;
	gdouble _tmp0_;
	gdouble _tmp1_;
	PomodoroDisabledState* _tmp2_;
	PomodoroTimerState* _tmp3_;
	PomodoroTimerState* result;
#line 113 "../src/timer-state.vala"
	self = (PomodoroDisabledState*) base;
#line 116 "../src/timer-state.vala"
	_tmp0_ = pomodoro_timer_state_get_timestamp ((PomodoroTimerState*) self);
#line 116 "../src/timer-state.vala"
	_tmp1_ = _tmp0_;
#line 116 "../src/timer-state.vala"
	_tmp2_ = pomodoro_disabled_state_new_with_timestamp (_tmp1_);
#line 116 "../src/timer-state.vala"
	_tmp3_ = POMODORO_IS_TIMER_STATE (_tmp2_) ? ((PomodoroTimerState*) _tmp2_) : NULL;
#line 116 "../src/timer-state.vala"
	if (_tmp3_ == NULL) {
#line 116 "../src/timer-state.vala"
		_g_object_unref0 (_tmp2_);
#line 743 "timer-state.c"
	}
#line 116 "../src/timer-state.vala"
	result = _tmp3_;
#line 116 "../src/timer-state.vala"
	return result;
#line 749 "timer-state.c"
}

static gdouble
pomodoro_disabled_state_real_calculate_score (PomodoroTimerState* base,
                                              gdouble score,
                                              gdouble timestamp)
{
	PomodoroDisabledState * self;
	gdouble elapsed = 0.0;
	gdouble _tmp0_;
	gdouble _tmp1_;
	gdouble _tmp2_ = 0.0;
	gdouble result;
#line 119 "../src/timer-state.vala"
	self = (PomodoroDisabledState*) base;
#line 122 "../src/timer-state.vala"
	_tmp0_ = pomodoro_timer_state_get_timestamp ((PomodoroTimerState*) self);
#line 122 "../src/timer-state.vala"
	_tmp1_ = _tmp0_;
#line 122 "../src/timer-state.vala"
	elapsed = timestamp - _tmp1_;
#line 124 "../src/timer-state.vala"
	if (elapsed < POMODORO_TIME_TO_RESET_SCORE) {
#line 124 "../src/timer-state.vala"
		_tmp2_ = score;
#line 775 "timer-state.c"
	} else {
#line 124 "../src/timer-state.vala"
		_tmp2_ = 0.0;
#line 779 "timer-state.c"
	}
#line 124 "../src/timer-state.vala"
	result = _tmp2_;
#line 124 "../src/timer-state.vala"
	return result;
#line 785 "timer-state.c"
}

PomodoroDisabledState*
pomodoro_disabled_state_construct (GType object_type)
{
	PomodoroDisabledState * self = NULL;
#line 101 "../src/timer-state.vala"
	self = (PomodoroDisabledState*) pomodoro_timer_state_construct (object_type);
#line 101 "../src/timer-state.vala"
	return self;
#line 796 "timer-state.c"
}

PomodoroDisabledState*
pomodoro_disabled_state_new (void)
{
#line 101 "../src/timer-state.vala"
	return pomodoro_disabled_state_construct (POMODORO_TYPE_DISABLED_STATE);
#line 804 "timer-state.c"
}

static GObject *
pomodoro_disabled_state_constructor (GType type,
                                     guint n_construct_properties,
                                     GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	PomodoroDisabledState * self;
#line 103 "../src/timer-state.vala"
	parent_class = G_OBJECT_CLASS (pomodoro_disabled_state_parent_class);
#line 103 "../src/timer-state.vala"
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
#line 103 "../src/timer-state.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, POMODORO_TYPE_DISABLED_STATE, PomodoroDisabledState);
#line 105 "../src/timer-state.vala"
	pomodoro_timer_state_set_name ((PomodoroTimerState*) self, "null");
#line 103 "../src/timer-state.vala"
	return obj;
#line 825 "timer-state.c"
}

static void
pomodoro_disabled_state_class_init (PomodoroDisabledStateClass * klass,
                                    gpointer klass_data)
{
#line 101 "../src/timer-state.vala"
	pomodoro_disabled_state_parent_class = g_type_class_peek_parent (klass);
#line 101 "../src/timer-state.vala"
	((PomodoroTimerStateClass *) klass)->create_next_state = (PomodoroTimerState* (*) (PomodoroTimerState*, gdouble, gdouble)) pomodoro_disabled_state_real_create_next_state;
#line 101 "../src/timer-state.vala"
	((PomodoroTimerStateClass *) klass)->calculate_score = (gdouble (*) (PomodoroTimerState*, gdouble, gdouble)) pomodoro_disabled_state_real_calculate_score;
#line 101 "../src/timer-state.vala"
	G_OBJECT_CLASS (klass)->constructor = pomodoro_disabled_state_constructor;
#line 840 "timer-state.c"
}

static void
pomodoro_disabled_state_instance_init (PomodoroDisabledState * self,
                                       gpointer klass)
{
}

static GType
pomodoro_disabled_state_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (PomodoroDisabledStateClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) pomodoro_disabled_state_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (PomodoroDisabledState), 0, (GInstanceInitFunc) pomodoro_disabled_state_instance_init, NULL };
	GType pomodoro_disabled_state_type_id;
	pomodoro_disabled_state_type_id = g_type_register_static (POMODORO_TYPE_TIMER_STATE, "PomodoroDisabledState", &g_define_type_info, 0);
	return pomodoro_disabled_state_type_id;
}

GType
pomodoro_disabled_state_get_type (void)
{
	static volatile gsize pomodoro_disabled_state_type_id__once = 0;
	if (g_once_init_enter (&pomodoro_disabled_state_type_id__once)) {
		GType pomodoro_disabled_state_type_id;
		pomodoro_disabled_state_type_id = pomodoro_disabled_state_get_type_once ();
		g_once_init_leave (&pomodoro_disabled_state_type_id__once, pomodoro_disabled_state_type_id);
	}
	return pomodoro_disabled_state_type_id__once;
}

PomodoroPomodoroState*
pomodoro_pomodoro_state_construct_with_timestamp (GType object_type,
                                                  gdouble timestamp)
{
	PomodoroPomodoroState * self = NULL;
#line 139 "../src/timer-state.vala"
	self = (PomodoroPomodoroState*) pomodoro_timer_state_construct (object_type);
#line 141 "../src/timer-state.vala"
	pomodoro_timer_state_set_timestamp ((PomodoroTimerState*) self, timestamp);
#line 139 "../src/timer-state.vala"
	return self;
#line 881 "timer-state.c"
}

PomodoroPomodoroState*
pomodoro_pomodoro_state_new_with_timestamp (gdouble timestamp)
{
#line 139 "../src/timer-state.vala"
	return pomodoro_pomodoro_state_construct_with_timestamp (POMODORO_TYPE_POMODORO_STATE, timestamp);
#line 889 "timer-state.c"
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 154 "../src/timer-state.vala"
	return self ? g_object_ref (self) : NULL;
#line 897 "timer-state.c"
}

static PomodoroTimerState*
pomodoro_pomodoro_state_real_create_next_state (PomodoroTimerState* base,
                                                gdouble score,
                                                gdouble timestamp)
{
	PomodoroPomodoroState * self;
	gdouble score_limit = 0.0;
	GSettings* _tmp0_;
	GSettings* _tmp1_;
	GSettings* _tmp2_;
	gdouble _tmp3_;
	gdouble min_long_break_score = 0.0;
	PomodoroTimerState* _tmp4_ = NULL;
	PomodoroTimerState* next_state = NULL;
	PomodoroTimerState* _tmp9_;
	gdouble _tmp10_;
	gdouble _tmp11_;
	gdouble _tmp12_;
	gdouble _tmp13_;
	PomodoroTimerState* result;
#line 144 "../src/timer-state.vala"
	self = (PomodoroPomodoroState*) base;
#line 147 "../src/timer-state.vala"
	_tmp0_ = pomodoro_get_settings ();
#line 147 "../src/timer-state.vala"
	_tmp1_ = g_settings_get_child (_tmp0_, "preferences");
#line 147 "../src/timer-state.vala"
	_tmp2_ = _tmp1_;
#line 147 "../src/timer-state.vala"
	_tmp3_ = g_settings_get_double (_tmp2_, "long-break-interval");
#line 147 "../src/timer-state.vala"
	_g_object_unref0 (_tmp2_);
#line 147 "../src/timer-state.vala"
	score_limit = _tmp3_;
#line 151 "../src/timer-state.vala"
	min_long_break_score = MAX (score_limit * POMODORO_POMODORO_THRESHOLD, score_limit - POMODORO_MISSING_SCORE_THRESHOLD);
#line 154 "../src/timer-state.vala"
	if (score >= min_long_break_score) {
#line 938 "timer-state.c"
		PomodoroLongBreakState* _tmp5_;
		PomodoroTimerState* _tmp6_;
#line 155 "../src/timer-state.vala"
		_tmp5_ = pomodoro_long_break_state_new_with_timestamp (timestamp);
#line 155 "../src/timer-state.vala"
		_tmp6_ = POMODORO_IS_TIMER_STATE (_tmp5_) ? ((PomodoroTimerState*) _tmp5_) : NULL;
#line 155 "../src/timer-state.vala"
		if (_tmp6_ == NULL) {
#line 155 "../src/timer-state.vala"
			_g_object_unref0 (_tmp5_);
#line 949 "timer-state.c"
		}
#line 155 "../src/timer-state.vala"
		_g_object_unref0 (_tmp4_);
#line 155 "../src/timer-state.vala"
		_tmp4_ = _tmp6_;
#line 955 "timer-state.c"
	} else {
		PomodoroShortBreakState* _tmp7_;
		PomodoroTimerState* _tmp8_;
#line 156 "../src/timer-state.vala"
		_tmp7_ = pomodoro_short_break_state_new_with_timestamp (timestamp);
#line 156 "../src/timer-state.vala"
		_tmp8_ = POMODORO_IS_TIMER_STATE (_tmp7_) ? ((PomodoroTimerState*) _tmp7_) : NULL;
#line 156 "../src/timer-state.vala"
		if (_tmp8_ == NULL) {
#line 156 "../src/timer-state.vala"
			_g_object_unref0 (_tmp7_);
#line 967 "timer-state.c"
		}
#line 156 "../src/timer-state.vala"
		_g_object_unref0 (_tmp4_);
#line 156 "../src/timer-state.vala"
		_tmp4_ = _tmp8_;
#line 973 "timer-state.c"
	}
#line 154 "../src/timer-state.vala"
	_tmp9_ = _g_object_ref0 (_tmp4_);
#line 154 "../src/timer-state.vala"
	next_state = _tmp9_;
#line 158 "../src/timer-state.vala"
	_tmp10_ = pomodoro_timer_state_get_elapsed ((PomodoroTimerState*) self);
#line 158 "../src/timer-state.vala"
	_tmp11_ = _tmp10_;
#line 158 "../src/timer-state.vala"
	_tmp12_ = pomodoro_timer_state_get_duration ((PomodoroTimerState*) self);
#line 158 "../src/timer-state.vala"
	_tmp13_ = _tmp12_;
#line 158 "../src/timer-state.vala"
	pomodoro_timer_state_set_elapsed (next_state, MAX (_tmp11_ - _tmp13_, 0.0));
#line 160 "../src/timer-state.vala"
	result = next_state;
#line 160 "../src/timer-state.vala"
	_g_object_unref0 (_tmp4_);
#line 160 "../src/timer-state.vala"
	return result;
#line 995 "timer-state.c"
}

static gdouble
pomodoro_pomodoro_state_real_calculate_score (PomodoroTimerState* base,
                                              gdouble score,
                                              gdouble timestamp)
{
	PomodoroPomodoroState * self;
	gdouble _tmp0_ = 0.0;
	gdouble _tmp1_;
	gdouble _tmp2_;
	gdouble achieved_score = 0.0;
	gdouble _tmp9_ = 0.0;
	gboolean _tmp10_ = FALSE;
	gdouble _tmp11_;
	gdouble _tmp12_;
	gdouble result;
#line 163 "../src/timer-state.vala"
	self = (PomodoroPomodoroState*) base;
#line 166 "../src/timer-state.vala"
	_tmp1_ = pomodoro_timer_state_get_duration ((PomodoroTimerState*) self);
#line 166 "../src/timer-state.vala"
	_tmp2_ = _tmp1_;
#line 166 "../src/timer-state.vala"
	if (_tmp2_ > 0.0) {
#line 1021 "timer-state.c"
		gdouble _tmp3_;
		gdouble _tmp4_;
		gdouble _tmp5_;
		gdouble _tmp6_;
		gdouble _tmp7_;
		gdouble _tmp8_;
#line 167 "../src/timer-state.vala"
		_tmp3_ = pomodoro_timer_state_get_elapsed ((PomodoroTimerState*) self);
#line 167 "../src/timer-state.vala"
		_tmp4_ = _tmp3_;
#line 167 "../src/timer-state.vala"
		_tmp5_ = pomodoro_timer_state_get_duration ((PomodoroTimerState*) self);
#line 167 "../src/timer-state.vala"
		_tmp6_ = _tmp5_;
#line 167 "../src/timer-state.vala"
		_tmp7_ = pomodoro_timer_state_get_duration ((PomodoroTimerState*) self);
#line 167 "../src/timer-state.vala"
		_tmp8_ = _tmp7_;
#line 167 "../src/timer-state.vala"
		_tmp0_ = MIN (_tmp4_, _tmp6_) / _tmp8_;
#line 1042 "timer-state.c"
	} else {
#line 168 "../src/timer-state.vala"
		_tmp0_ = 0.0;
#line 1046 "timer-state.c"
	}
#line 166 "../src/timer-state.vala"
	achieved_score = _tmp0_;
#line 170 "../src/timer-state.vala"
	_tmp11_ = pomodoro_timer_state_get_duration ((PomodoroTimerState*) self);
#line 170 "../src/timer-state.vala"
	_tmp12_ = _tmp11_;
#line 170 "../src/timer-state.vala"
	if (_tmp12_ <= POMODORO_MIN_POMODORO_TIME) {
#line 170 "../src/timer-state.vala"
		_tmp10_ = TRUE;
#line 1058 "timer-state.c"
	} else {
		gdouble _tmp13_;
		gdouble _tmp14_;
#line 170 "../src/timer-state.vala"
		_tmp13_ = pomodoro_timer_state_get_elapsed ((PomodoroTimerState*) self);
#line 170 "../src/timer-state.vala"
		_tmp14_ = _tmp13_;
#line 170 "../src/timer-state.vala"
		_tmp10_ = _tmp14_ >= POMODORO_MIN_POMODORO_TIME;
#line 1068 "timer-state.c"
	}
#line 170 "../src/timer-state.vala"
	if (_tmp10_) {
#line 171 "../src/timer-state.vala"
		_tmp9_ = score + achieved_score;
#line 1074 "timer-state.c"
	} else {
#line 171 "../src/timer-state.vala"
		_tmp9_ = score;
#line 1078 "timer-state.c"
	}
#line 170 "../src/timer-state.vala"
	result = _tmp9_;
#line 170 "../src/timer-state.vala"
	return result;
#line 1084 "timer-state.c"
}

PomodoroPomodoroState*
pomodoro_pomodoro_state_construct (GType object_type)
{
	PomodoroPomodoroState * self = NULL;
#line 128 "../src/timer-state.vala"
	self = (PomodoroPomodoroState*) pomodoro_timer_state_construct (object_type);
#line 128 "../src/timer-state.vala"
	return self;
#line 1095 "timer-state.c"
}

PomodoroPomodoroState*
pomodoro_pomodoro_state_new (void)
{
#line 128 "../src/timer-state.vala"
	return pomodoro_pomodoro_state_construct (POMODORO_TYPE_POMODORO_STATE);
#line 1103 "timer-state.c"
}

static GObject *
pomodoro_pomodoro_state_constructor (GType type,
                                     guint n_construct_properties,
                                     GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	PomodoroPomodoroState * self;
	GSettings* _tmp0_;
	GSettings* _tmp1_;
	GSettings* _tmp2_;
#line 130 "../src/timer-state.vala"
	parent_class = G_OBJECT_CLASS (pomodoro_pomodoro_state_parent_class);
#line 130 "../src/timer-state.vala"
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
#line 130 "../src/timer-state.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, POMODORO_TYPE_POMODORO_STATE, PomodoroPomodoroState);
#line 132 "../src/timer-state.vala"
	pomodoro_timer_state_set_name ((PomodoroTimerState*) self, "pomodoro");
#line 134 "../src/timer-state.vala"
	_tmp0_ = pomodoro_get_settings ();
#line 134 "../src/timer-state.vala"
	_tmp1_ = g_settings_get_child (_tmp0_, "preferences");
#line 134 "../src/timer-state.vala"
	_tmp2_ = _tmp1_;
#line 134 "../src/timer-state.vala"
	pomodoro_timer_state_set_duration ((PomodoroTimerState*) self, g_settings_get_double (_tmp2_, "pomodoro-duration"));
#line 134 "../src/timer-state.vala"
	_g_object_unref0 (_tmp2_);
#line 130 "../src/timer-state.vala"
	return obj;
#line 1137 "timer-state.c"
}

static void
pomodoro_pomodoro_state_class_init (PomodoroPomodoroStateClass * klass,
                                    gpointer klass_data)
{
#line 128 "../src/timer-state.vala"
	pomodoro_pomodoro_state_parent_class = g_type_class_peek_parent (klass);
#line 128 "../src/timer-state.vala"
	((PomodoroTimerStateClass *) klass)->create_next_state = (PomodoroTimerState* (*) (PomodoroTimerState*, gdouble, gdouble)) pomodoro_pomodoro_state_real_create_next_state;
#line 128 "../src/timer-state.vala"
	((PomodoroTimerStateClass *) klass)->calculate_score = (gdouble (*) (PomodoroTimerState*, gdouble, gdouble)) pomodoro_pomodoro_state_real_calculate_score;
#line 128 "../src/timer-state.vala"
	G_OBJECT_CLASS (klass)->constructor = pomodoro_pomodoro_state_constructor;
#line 1152 "timer-state.c"
}

static void
pomodoro_pomodoro_state_instance_init (PomodoroPomodoroState * self,
                                       gpointer klass)
{
}

static GType
pomodoro_pomodoro_state_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (PomodoroPomodoroStateClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) pomodoro_pomodoro_state_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (PomodoroPomodoroState), 0, (GInstanceInitFunc) pomodoro_pomodoro_state_instance_init, NULL };
	GType pomodoro_pomodoro_state_type_id;
	pomodoro_pomodoro_state_type_id = g_type_register_static (POMODORO_TYPE_TIMER_STATE, "PomodoroPomodoroState", &g_define_type_info, 0);
	return pomodoro_pomodoro_state_type_id;
}

GType
pomodoro_pomodoro_state_get_type (void)
{
	static volatile gsize pomodoro_pomodoro_state_type_id__once = 0;
	if (g_once_init_enter (&pomodoro_pomodoro_state_type_id__once)) {
		GType pomodoro_pomodoro_state_type_id;
		pomodoro_pomodoro_state_type_id = pomodoro_pomodoro_state_get_type_once ();
		g_once_init_leave (&pomodoro_pomodoro_state_type_id__once, pomodoro_pomodoro_state_type_id);
	}
	return pomodoro_pomodoro_state_type_id__once;
}

static PomodoroTimerState*
pomodoro_break_state_real_create_next_state (PomodoroTimerState* base,
                                             gdouble score,
                                             gdouble timestamp)
{
	PomodoroBreakState * self;
	PomodoroPomodoroState* _tmp0_;
	PomodoroTimerState* _tmp1_;
	PomodoroTimerState* result;
#line 177 "../src/timer-state.vala"
	self = (PomodoroBreakState*) base;
#line 180 "../src/timer-state.vala"
	_tmp0_ = pomodoro_pomodoro_state_new_with_timestamp (timestamp);
#line 180 "../src/timer-state.vala"
	_tmp1_ = POMODORO_IS_TIMER_STATE (_tmp0_) ? ((PomodoroTimerState*) _tmp0_) : NULL;
#line 180 "../src/timer-state.vala"
	if (_tmp1_ == NULL) {
#line 180 "../src/timer-state.vala"
		_g_object_unref0 (_tmp0_);
#line 1201 "timer-state.c"
	}
#line 180 "../src/timer-state.vala"
	result = _tmp1_;
#line 180 "../src/timer-state.vala"
	return result;
#line 1207 "timer-state.c"
}

PomodoroBreakState*
pomodoro_break_state_construct (GType object_type)
{
	PomodoroBreakState * self = NULL;
#line 175 "../src/timer-state.vala"
	self = (PomodoroBreakState*) pomodoro_timer_state_construct (object_type);
#line 175 "../src/timer-state.vala"
	return self;
#line 1218 "timer-state.c"
}

static void
pomodoro_break_state_class_init (PomodoroBreakStateClass * klass,
                                 gpointer klass_data)
{
#line 175 "../src/timer-state.vala"
	pomodoro_break_state_parent_class = g_type_class_peek_parent (klass);
#line 175 "../src/timer-state.vala"
	((PomodoroTimerStateClass *) klass)->create_next_state = (PomodoroTimerState* (*) (PomodoroTimerState*, gdouble, gdouble)) pomodoro_break_state_real_create_next_state;
#line 1229 "timer-state.c"
}

static void
pomodoro_break_state_instance_init (PomodoroBreakState * self,
                                    gpointer klass)
{
}

static GType
pomodoro_break_state_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (PomodoroBreakStateClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) pomodoro_break_state_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (PomodoroBreakState), 0, (GInstanceInitFunc) pomodoro_break_state_instance_init, NULL };
	GType pomodoro_break_state_type_id;
	pomodoro_break_state_type_id = g_type_register_static (POMODORO_TYPE_TIMER_STATE, "PomodoroBreakState", &g_define_type_info, G_TYPE_FLAG_ABSTRACT);
	return pomodoro_break_state_type_id;
}

GType
pomodoro_break_state_get_type (void)
{
	static volatile gsize pomodoro_break_state_type_id__once = 0;
	if (g_once_init_enter (&pomodoro_break_state_type_id__once)) {
		GType pomodoro_break_state_type_id;
		pomodoro_break_state_type_id = pomodoro_break_state_get_type_once ();
		g_once_init_leave (&pomodoro_break_state_type_id__once, pomodoro_break_state_type_id);
	}
	return pomodoro_break_state_type_id__once;
}

PomodoroShortBreakState*
pomodoro_short_break_state_construct_with_timestamp (GType object_type,
                                                     gdouble timestamp)
{
	PomodoroShortBreakState * self = NULL;
#line 195 "../src/timer-state.vala"
	self = (PomodoroShortBreakState*) pomodoro_break_state_construct (object_type);
#line 197 "../src/timer-state.vala"
	pomodoro_timer_state_set_timestamp ((PomodoroTimerState*) self, timestamp);
#line 195 "../src/timer-state.vala"
	return self;
#line 1270 "timer-state.c"
}

PomodoroShortBreakState*
pomodoro_short_break_state_new_with_timestamp (gdouble timestamp)
{
#line 195 "../src/timer-state.vala"
	return pomodoro_short_break_state_construct_with_timestamp (POMODORO_TYPE_SHORT_BREAK_STATE, timestamp);
#line 1278 "timer-state.c"
}

PomodoroShortBreakState*
pomodoro_short_break_state_construct (GType object_type)
{
	PomodoroShortBreakState * self = NULL;
#line 184 "../src/timer-state.vala"
	self = (PomodoroShortBreakState*) pomodoro_break_state_construct (object_type);
#line 184 "../src/timer-state.vala"
	return self;
#line 1289 "timer-state.c"
}

PomodoroShortBreakState*
pomodoro_short_break_state_new (void)
{
#line 184 "../src/timer-state.vala"
	return pomodoro_short_break_state_construct (POMODORO_TYPE_SHORT_BREAK_STATE);
#line 1297 "timer-state.c"
}

static GObject *
pomodoro_short_break_state_constructor (GType type,
                                        guint n_construct_properties,
                                        GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	PomodoroShortBreakState * self;
	GSettings* _tmp0_;
	GSettings* _tmp1_;
	GSettings* _tmp2_;
#line 186 "../src/timer-state.vala"
	parent_class = G_OBJECT_CLASS (pomodoro_short_break_state_parent_class);
#line 186 "../src/timer-state.vala"
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
#line 186 "../src/timer-state.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, POMODORO_TYPE_SHORT_BREAK_STATE, PomodoroShortBreakState);
#line 188 "../src/timer-state.vala"
	pomodoro_timer_state_set_name ((PomodoroTimerState*) self, "short-break");
#line 190 "../src/timer-state.vala"
	_tmp0_ = pomodoro_get_settings ();
#line 190 "../src/timer-state.vala"
	_tmp1_ = g_settings_get_child (_tmp0_, "preferences");
#line 190 "../src/timer-state.vala"
	_tmp2_ = _tmp1_;
#line 190 "../src/timer-state.vala"
	pomodoro_timer_state_set_duration ((PomodoroTimerState*) self, g_settings_get_double (_tmp2_, "short-break-duration"));
#line 190 "../src/timer-state.vala"
	_g_object_unref0 (_tmp2_);
#line 186 "../src/timer-state.vala"
	return obj;
#line 1331 "timer-state.c"
}

static void
pomodoro_short_break_state_class_init (PomodoroShortBreakStateClass * klass,
                                       gpointer klass_data)
{
#line 184 "../src/timer-state.vala"
	pomodoro_short_break_state_parent_class = g_type_class_peek_parent (klass);
#line 184 "../src/timer-state.vala"
	G_OBJECT_CLASS (klass)->constructor = pomodoro_short_break_state_constructor;
#line 1342 "timer-state.c"
}

static void
pomodoro_short_break_state_instance_init (PomodoroShortBreakState * self,
                                          gpointer klass)
{
}

static GType
pomodoro_short_break_state_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (PomodoroShortBreakStateClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) pomodoro_short_break_state_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (PomodoroShortBreakState), 0, (GInstanceInitFunc) pomodoro_short_break_state_instance_init, NULL };
	GType pomodoro_short_break_state_type_id;
	pomodoro_short_break_state_type_id = g_type_register_static (POMODORO_TYPE_BREAK_STATE, "PomodoroShortBreakState", &g_define_type_info, 0);
	return pomodoro_short_break_state_type_id;
}

GType
pomodoro_short_break_state_get_type (void)
{
	static volatile gsize pomodoro_short_break_state_type_id__once = 0;
	if (g_once_init_enter (&pomodoro_short_break_state_type_id__once)) {
		GType pomodoro_short_break_state_type_id;
		pomodoro_short_break_state_type_id = pomodoro_short_break_state_get_type_once ();
		g_once_init_leave (&pomodoro_short_break_state_type_id__once, pomodoro_short_break_state_type_id);
	}
	return pomodoro_short_break_state_type_id__once;
}

PomodoroLongBreakState*
pomodoro_long_break_state_construct_with_timestamp (GType object_type,
                                                    gdouble timestamp)
{
	PomodoroLongBreakState * self = NULL;
#line 212 "../src/timer-state.vala"
	self = (PomodoroLongBreakState*) pomodoro_break_state_construct (object_type);
#line 214 "../src/timer-state.vala"
	pomodoro_timer_state_set_timestamp ((PomodoroTimerState*) self, timestamp);
#line 212 "../src/timer-state.vala"
	return self;
#line 1383 "timer-state.c"
}

PomodoroLongBreakState*
pomodoro_long_break_state_new_with_timestamp (gdouble timestamp)
{
#line 212 "../src/timer-state.vala"
	return pomodoro_long_break_state_construct_with_timestamp (POMODORO_TYPE_LONG_BREAK_STATE, timestamp);
#line 1391 "timer-state.c"
}

static gdouble
pomodoro_long_break_state_real_calculate_score (PomodoroTimerState* base,
                                                gdouble score,
                                                gdouble timestamp)
{
	PomodoroLongBreakState * self;
	gdouble short_break_duration = 0.0;
	GSettings* _tmp0_;
	GSettings* _tmp1_;
	GSettings* _tmp2_;
	gdouble _tmp3_;
	gdouble long_break_duration = 0.0;
	gdouble _tmp4_;
	gdouble _tmp5_;
	gdouble min_elapsed = 0.0;
	gdouble _tmp6_ = 0.0;
	gboolean _tmp7_ = FALSE;
	gdouble _tmp8_;
	gdouble _tmp9_;
	gdouble result;
#line 217 "../src/timer-state.vala"
	self = (PomodoroLongBreakState*) base;
#line 220 "../src/timer-state.vala"
	_tmp0_ = pomodoro_get_settings ();
#line 220 "../src/timer-state.vala"
	_tmp1_ = g_settings_get_child (_tmp0_, "preferences");
#line 220 "../src/timer-state.vala"
	_tmp2_ = _tmp1_;
#line 220 "../src/timer-state.vala"
	_tmp3_ = g_settings_get_double (_tmp2_, "short-break-duration");
#line 220 "../src/timer-state.vala"
	_g_object_unref0 (_tmp2_);
#line 220 "../src/timer-state.vala"
	short_break_duration = _tmp3_;
#line 223 "../src/timer-state.vala"
	_tmp4_ = pomodoro_timer_state_get_duration ((PomodoroTimerState*) self);
#line 223 "../src/timer-state.vala"
	_tmp5_ = _tmp4_;
#line 223 "../src/timer-state.vala"
	long_break_duration = _tmp5_;
#line 225 "../src/timer-state.vala"
	min_elapsed = short_break_duration + ((long_break_duration - short_break_duration) * POMODORO_SHORT_TO_LONG_BREAK_THRESHOLD);
#line 229 "../src/timer-state.vala"
	_tmp8_ = pomodoro_timer_state_get_elapsed ((PomodoroTimerState*) self);
#line 229 "../src/timer-state.vala"
	_tmp9_ = _tmp8_;
#line 229 "../src/timer-state.vala"
	if (_tmp9_ >= min_elapsed) {
#line 229 "../src/timer-state.vala"
		_tmp7_ = TRUE;
#line 1444 "timer-state.c"
	} else {
		gdouble _tmp10_;
		gdouble _tmp11_;
#line 229 "../src/timer-state.vala"
		_tmp10_ = pomodoro_timer_state_get_timestamp ((PomodoroTimerState*) self);
#line 229 "../src/timer-state.vala"
		_tmp11_ = _tmp10_;
#line 229 "../src/timer-state.vala"
		_tmp7_ = (timestamp - _tmp11_) >= min_elapsed;
#line 1454 "timer-state.c"
	}
#line 229 "../src/timer-state.vala"
	if (_tmp7_) {
#line 230 "../src/timer-state.vala"
		_tmp6_ = 0.0;
#line 1460 "timer-state.c"
	} else {
#line 230 "../src/timer-state.vala"
		_tmp6_ = score;
#line 1464 "timer-state.c"
	}
#line 229 "../src/timer-state.vala"
	result = _tmp6_;
#line 229 "../src/timer-state.vala"
	return result;
#line 1470 "timer-state.c"
}

PomodoroLongBreakState*
pomodoro_long_break_state_construct (GType object_type)
{
	PomodoroLongBreakState * self = NULL;
#line 201 "../src/timer-state.vala"
	self = (PomodoroLongBreakState*) pomodoro_break_state_construct (object_type);
#line 201 "../src/timer-state.vala"
	return self;
#line 1481 "timer-state.c"
}

PomodoroLongBreakState*
pomodoro_long_break_state_new (void)
{
#line 201 "../src/timer-state.vala"
	return pomodoro_long_break_state_construct (POMODORO_TYPE_LONG_BREAK_STATE);
#line 1489 "timer-state.c"
}

static GObject *
pomodoro_long_break_state_constructor (GType type,
                                       guint n_construct_properties,
                                       GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	PomodoroLongBreakState * self;
	GSettings* _tmp0_;
	GSettings* _tmp1_;
	GSettings* _tmp2_;
#line 203 "../src/timer-state.vala"
	parent_class = G_OBJECT_CLASS (pomodoro_long_break_state_parent_class);
#line 203 "../src/timer-state.vala"
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
#line 203 "../src/timer-state.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, POMODORO_TYPE_LONG_BREAK_STATE, PomodoroLongBreakState);
#line 205 "../src/timer-state.vala"
	pomodoro_timer_state_set_name ((PomodoroTimerState*) self, "long-break");
#line 207 "../src/timer-state.vala"
	_tmp0_ = pomodoro_get_settings ();
#line 207 "../src/timer-state.vala"
	_tmp1_ = g_settings_get_child (_tmp0_, "preferences");
#line 207 "../src/timer-state.vala"
	_tmp2_ = _tmp1_;
#line 207 "../src/timer-state.vala"
	pomodoro_timer_state_set_duration ((PomodoroTimerState*) self, g_settings_get_double (_tmp2_, "long-break-duration"));
#line 207 "../src/timer-state.vala"
	_g_object_unref0 (_tmp2_);
#line 203 "../src/timer-state.vala"
	return obj;
#line 1523 "timer-state.c"
}

static void
pomodoro_long_break_state_class_init (PomodoroLongBreakStateClass * klass,
                                      gpointer klass_data)
{
#line 201 "../src/timer-state.vala"
	pomodoro_long_break_state_parent_class = g_type_class_peek_parent (klass);
#line 201 "../src/timer-state.vala"
	((PomodoroTimerStateClass *) klass)->calculate_score = (gdouble (*) (PomodoroTimerState*, gdouble, gdouble)) pomodoro_long_break_state_real_calculate_score;
#line 201 "../src/timer-state.vala"
	G_OBJECT_CLASS (klass)->constructor = pomodoro_long_break_state_constructor;
#line 1536 "timer-state.c"
}

static void
pomodoro_long_break_state_instance_init (PomodoroLongBreakState * self,
                                         gpointer klass)
{
}

static GType
pomodoro_long_break_state_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (PomodoroLongBreakStateClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) pomodoro_long_break_state_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (PomodoroLongBreakState), 0, (GInstanceInitFunc) pomodoro_long_break_state_instance_init, NULL };
	GType pomodoro_long_break_state_type_id;
	pomodoro_long_break_state_type_id = g_type_register_static (POMODORO_TYPE_BREAK_STATE, "PomodoroLongBreakState", &g_define_type_info, 0);
	return pomodoro_long_break_state_type_id;
}

GType
pomodoro_long_break_state_get_type (void)
{
	static volatile gsize pomodoro_long_break_state_type_id__once = 0;
	if (g_once_init_enter (&pomodoro_long_break_state_type_id__once)) {
		GType pomodoro_long_break_state_type_id;
		pomodoro_long_break_state_type_id = pomodoro_long_break_state_get_type_once ();
		g_once_init_leave (&pomodoro_long_break_state_type_id__once, pomodoro_long_break_state_type_id);
	}
	return pomodoro_long_break_state_type_id__once;
}

